# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.as_code_ingestion_time_partition_clause_dto import (
    AsCodeIngestionTimePartitionClauseDto,
)
from sifflet_sdk.client.models.as_code_integer_range_partition_clause_dto import (
    AsCodeIntegerRangePartitionClauseDto,
)
from sifflet_sdk.client.models.as_code_time_unit_column_partition_clause_dto import (
    AsCodeTimeUnitColumnPartitionClauseDto,
)
from typing_extensions import Literal, Self

ASCODECOMPLETENESSMONITORPARAMSDTOALLOFPARTITION_ONE_OF_SCHEMAS = [
    "AsCodeIngestionTimePartitionClauseDto",
    "AsCodeIntegerRangePartitionClauseDto",
    "AsCodeTimeUnitColumnPartitionClauseDto",
]


class AsCodeCompletenessMonitorParamsDtoAllOfPartition(BaseModel):
    """
    AsCodeCompletenessMonitorParamsDtoAllOfPartition
    """

    # data type: AsCodeIngestionTimePartitionClauseDto
    oneof_schema_1_validator: Optional[AsCodeIngestionTimePartitionClauseDto] = None
    # data type: AsCodeIntegerRangePartitionClauseDto
    oneof_schema_2_validator: Optional[AsCodeIntegerRangePartitionClauseDto] = None
    # data type: AsCodeTimeUnitColumnPartitionClauseDto
    oneof_schema_3_validator: Optional[AsCodeTimeUnitColumnPartitionClauseDto] = None
    actual_instance: Optional[
        Union[
            AsCodeIngestionTimePartitionClauseDto,
            AsCodeIntegerRangePartitionClauseDto,
            AsCodeTimeUnitColumnPartitionClauseDto,
        ]
    ] = None
    one_of_schemas: Set[str] = {
        "AsCodeIngestionTimePartitionClauseDto",
        "AsCodeIntegerRangePartitionClauseDto",
        "AsCodeTimeUnitColumnPartitionClauseDto",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = AsCodeCompletenessMonitorParamsDtoAllOfPartition.model_construct()
        error_messages = []
        match = 0
        # validate data type: AsCodeIngestionTimePartitionClauseDto
        if not isinstance(v, AsCodeIngestionTimePartitionClauseDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AsCodeIngestionTimePartitionClauseDto`")
        else:
            match += 1
        # validate data type: AsCodeIntegerRangePartitionClauseDto
        if not isinstance(v, AsCodeIntegerRangePartitionClauseDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AsCodeIntegerRangePartitionClauseDto`")
        else:
            match += 1
        # validate data type: AsCodeTimeUnitColumnPartitionClauseDto
        if not isinstance(v, AsCodeTimeUnitColumnPartitionClauseDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AsCodeTimeUnitColumnPartitionClauseDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in AsCodeCompletenessMonitorParamsDtoAllOfPartition with oneOf schemas: AsCodeIngestionTimePartitionClauseDto, AsCodeIntegerRangePartitionClauseDto, AsCodeTimeUnitColumnPartitionClauseDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in AsCodeCompletenessMonitorParamsDtoAllOfPartition with oneOf schemas: AsCodeIngestionTimePartitionClauseDto, AsCodeIntegerRangePartitionClauseDto, AsCodeTimeUnitColumnPartitionClauseDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("kind")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `kind` in the input.")

        # check if data type is `AsCodeIngestionTimePartitionClauseDto`
        if _data_type == "IngestionTime":
            instance.actual_instance = AsCodeIngestionTimePartitionClauseDto.from_json(json_str)
            return instance

        # check if data type is `AsCodeIntegerRangePartitionClauseDto`
        if _data_type == "IntegerRange":
            instance.actual_instance = AsCodeIntegerRangePartitionClauseDto.from_json(json_str)
            return instance

        # check if data type is `AsCodeTimeUnitColumnPartitionClauseDto`
        if _data_type == "TimeUnitColumn":
            instance.actual_instance = AsCodeTimeUnitColumnPartitionClauseDto.from_json(json_str)
            return instance

        # check if data type is `AsCodeIngestionTimePartitionClauseDto`
        if _data_type == "AsCodeIngestionTimePartitionClauseDto":
            instance.actual_instance = AsCodeIngestionTimePartitionClauseDto.from_json(json_str)
            return instance

        # check if data type is `AsCodeIntegerRangePartitionClauseDto`
        if _data_type == "AsCodeIntegerRangePartitionClauseDto":
            instance.actual_instance = AsCodeIntegerRangePartitionClauseDto.from_json(json_str)
            return instance

        # check if data type is `AsCodeTimeUnitColumnPartitionClauseDto`
        if _data_type == "AsCodeTimeUnitColumnPartitionClauseDto":
            instance.actual_instance = AsCodeTimeUnitColumnPartitionClauseDto.from_json(json_str)
            return instance

        # deserialize data into AsCodeIngestionTimePartitionClauseDto
        try:
            instance.actual_instance = AsCodeIngestionTimePartitionClauseDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AsCodeIntegerRangePartitionClauseDto
        try:
            instance.actual_instance = AsCodeIntegerRangePartitionClauseDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AsCodeTimeUnitColumnPartitionClauseDto
        try:
            instance.actual_instance = AsCodeTimeUnitColumnPartitionClauseDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into AsCodeCompletenessMonitorParamsDtoAllOfPartition with oneOf schemas: AsCodeIngestionTimePartitionClauseDto, AsCodeIntegerRangePartitionClauseDto, AsCodeTimeUnitColumnPartitionClauseDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into AsCodeCompletenessMonitorParamsDtoAllOfPartition with oneOf schemas: AsCodeIngestionTimePartitionClauseDto, AsCodeIntegerRangePartitionClauseDto, AsCodeTimeUnitColumnPartitionClauseDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[
            Dict[str, Any],
            AsCodeIngestionTimePartitionClauseDto,
            AsCodeIntegerRangePartitionClauseDto,
            AsCodeTimeUnitColumnPartitionClauseDto,
        ]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
