# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from importlib import import_module
from typing import TYPE_CHECKING, Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Self

if TYPE_CHECKING:
    from sifflet_sdk.client.models.as_code_custom_metadata_entry_label_value_reference_dto import (
        AsCodeCustomMetadataEntryLabelValueReferenceDto,
    )
    from sifflet_sdk.client.models.as_code_custom_metadata_entry_string_value_reference_dto import (
        AsCodeCustomMetadataEntryStringValueReferenceDto,
    )
    from sifflet_sdk.client.models.as_code_custom_metadata_entry_user_value_reference_dto import (
        AsCodeCustomMetadataEntryUserValueReferenceDto,
    )


class AsCodeCustomMetadataEntryValueReferenceDto(BaseModel):
    """
    AsCodeCustomMetadataEntryValueReferenceDto
    """  # noqa: E501

    custom_metadata_name: Optional[StrictStr] = Field(default=None, alias="customMetadataName")
    kind: StrictStr
    __properties: ClassVar[List[str]] = ["customMetadataName", "kind"]

    @field_validator("kind")
    def kind_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["Label", "String", "User"]):
            raise ValueError("must be one of enum values ('Label', 'String', 'User')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = "kind"

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        "AsCodeCustomMetadataEntryLabelValueReferenceDto": "AsCodeCustomMetadataEntryLabelValueReferenceDto",
        "AsCodeCustomMetadataEntryStringValueReferenceDto": "AsCodeCustomMetadataEntryStringValueReferenceDto",
        "AsCodeCustomMetadataEntryUserValueReferenceDto": "AsCodeCustomMetadataEntryUserValueReferenceDto",
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[
        Union[
            AsCodeCustomMetadataEntryLabelValueReferenceDto,
            AsCodeCustomMetadataEntryStringValueReferenceDto,
            AsCodeCustomMetadataEntryUserValueReferenceDto,
        ]
    ]:
        """Create an instance of AsCodeCustomMetadataEntryValueReferenceDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[
        Union[
            AsCodeCustomMetadataEntryLabelValueReferenceDto,
            AsCodeCustomMetadataEntryStringValueReferenceDto,
            AsCodeCustomMetadataEntryUserValueReferenceDto,
        ]
    ]:
        """Create an instance of AsCodeCustomMetadataEntryValueReferenceDto from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type == "AsCodeCustomMetadataEntryLabelValueReferenceDto":
            return import_module(
                "sifflet_sdk.client.models.as_code_custom_metadata_entry_label_value_reference_dto"
            ).AsCodeCustomMetadataEntryLabelValueReferenceDto.from_dict(obj)
        if object_type == "AsCodeCustomMetadataEntryStringValueReferenceDto":
            return import_module(
                "sifflet_sdk.client.models.as_code_custom_metadata_entry_string_value_reference_dto"
            ).AsCodeCustomMetadataEntryStringValueReferenceDto.from_dict(obj)
        if object_type == "AsCodeCustomMetadataEntryUserValueReferenceDto":
            return import_module(
                "sifflet_sdk.client.models.as_code_custom_metadata_entry_user_value_reference_dto"
            ).AsCodeCustomMetadataEntryUserValueReferenceDto.from_dict(obj)

        raise ValueError(
            "AsCodeCustomMetadataEntryValueReferenceDto failed to lookup discriminator value from "
            + json.dumps(obj)
            + ". Discriminator property name: "
            + cls.__discriminator_property_name
            + ", mapping: "
            + json.dumps(cls.__discriminator_value_class_map)
        )
