# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.as_code_custom_metrics_monitor_params_dto_v1_all_of_partition import (
    AsCodeCustomMetricsMonitorParamsDtoV1AllOfPartition,
)
from sifflet_sdk.client.models.as_code_dynamic_threshold_dto_v1 import (
    AsCodeDynamicThresholdDtoV1,
)
from sifflet_sdk.client.models.as_code_group_by_clause_dto import AsCodeGroupByClauseDto
from sifflet_sdk.client.models.as_code_monitor_params_dto import AsCodeMonitorParamsDto
from sifflet_sdk.client.models.as_code_time_window_offset_clause_dto import (
    AsCodeTimeWindowOffsetClauseDto,
)
from typing_extensions import Self


class AsCodeCustomMetricsMonitorParamsDtoV1(AsCodeMonitorParamsDto):
    """
    AsCodeCustomMetricsMonitorParamsDtoV1
    """  # noqa: E501

    group_by: Optional[AsCodeGroupByClauseDto] = Field(default=None, alias="groupBy")
    partition: Optional[AsCodeCustomMetricsMonitorParamsDtoV1AllOfPartition] = None
    sql: StrictStr
    threshold: Optional[AsCodeDynamicThresholdDtoV1] = None
    time_window: Optional[AsCodeTimeWindowOffsetClauseDto] = Field(default=None, alias="timeWindow")
    __properties: ClassVar[List[str]] = ["kind", "groupBy", "partition", "sql", "threshold", "timeWindow"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AsCodeCustomMetricsMonitorParamsDtoV1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of group_by
        if self.group_by:
            _dict["groupBy"] = self.group_by.to_dict()
        # override the default output from pydantic by calling `to_dict()` of partition
        if self.partition:
            _dict["partition"] = self.partition.to_dict()
        # override the default output from pydantic by calling `to_dict()` of threshold
        if self.threshold:
            _dict["threshold"] = self.threshold.to_dict()
        # override the default output from pydantic by calling `to_dict()` of time_window
        if self.time_window:
            _dict["timeWindow"] = self.time_window.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AsCodeCustomMetricsMonitorParamsDtoV1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "kind": obj.get("kind"),
                "groupBy": AsCodeGroupByClauseDto.from_dict(obj["groupBy"]) if obj.get("groupBy") is not None else None,
                "partition": (
                    AsCodeCustomMetricsMonitorParamsDtoV1AllOfPartition.from_dict(obj["partition"])
                    if obj.get("partition") is not None
                    else None
                ),
                "sql": obj.get("sql"),
                "threshold": (
                    AsCodeDynamicThresholdDtoV1.from_dict(obj["threshold"])
                    if obj.get("threshold") is not None
                    else None
                ),
                "timeWindow": (
                    AsCodeTimeWindowOffsetClauseDto.from_dict(obj["timeWindow"])
                    if obj.get("timeWindow") is not None
                    else None
                ),
            }
        )
        return _obj
