# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import ConfigDict, Field
from sifflet_sdk.client.models.as_code_join_condition_dto import AsCodeJoinConditionDto
from sifflet_sdk.client.models.as_code_join_field_pair_dto import AsCodeJoinFieldPairDto
from typing_extensions import Self


class AsCodeEqualityJoinConditionDto(AsCodeJoinConditionDto):
    """
    AsCodeEqualityJoinConditionDto
    """  # noqa: E501

    field_pairs: Optional[List[AsCodeJoinFieldPairDto]] = Field(default=None, alias="fieldPairs")
    __properties: ClassVar[List[str]] = ["kind", "fieldPairs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AsCodeEqualityJoinConditionDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in field_pairs (list)
        _items = []
        if self.field_pairs:
            for _item_field_pairs in self.field_pairs:
                if _item_field_pairs:
                    _items.append(_item_field_pairs.to_dict())
            _dict["fieldPairs"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AsCodeEqualityJoinConditionDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "kind": obj.get("kind"),
                "fieldPairs": (
                    [AsCodeJoinFieldPairDto.from_dict(_item) for _item in obj["fieldPairs"]]
                    if obj.get("fieldPairs") is not None
                    else None
                ),
            }
        )
        return _obj
