# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import ConfigDict, Field, StrictStr, field_validator
from sifflet_sdk.client.models.as_code_monitor_params_dto import AsCodeMonitorParamsDto
from sifflet_sdk.client.models.as_code_referential_integrity_left_dto_v2 import (
    AsCodeReferentialIntegrityLeftDtoV2,
)
from sifflet_sdk.client.models.as_code_referential_integrity_monitor_params_dto_v2_all_of_threshold import (
    AsCodeReferentialIntegrityMonitorParamsDtoV2AllOfThreshold,
)
from sifflet_sdk.client.models.as_code_referential_integrity_right_dto import (
    AsCodeReferentialIntegrityRightDto,
)
from typing_extensions import Self


class AsCodeReferentialIntegrityMonitorParamsDtoV2(AsCodeMonitorParamsDto):
    """
    AsCodeReferentialIntegrityMonitorParamsDtoV2
    """  # noqa: E501

    left: AsCodeReferentialIntegrityLeftDtoV2
    match_type: StrictStr = Field(alias="matchType")
    right: AsCodeReferentialIntegrityRightDto
    threshold: AsCodeReferentialIntegrityMonitorParamsDtoV2AllOfThreshold
    __properties: ClassVar[List[str]] = ["kind", "left", "matchType", "right", "threshold"]

    @field_validator("match_type")
    def match_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["Full", "LeftOnRight", "RightOnLeft"]):
            raise ValueError("must be one of enum values ('Full', 'LeftOnRight', 'RightOnLeft')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AsCodeReferentialIntegrityMonitorParamsDtoV2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of left
        if self.left:
            _dict["left"] = self.left.to_dict()
        # override the default output from pydantic by calling `to_dict()` of right
        if self.right:
            _dict["right"] = self.right.to_dict()
        # override the default output from pydantic by calling `to_dict()` of threshold
        if self.threshold:
            _dict["threshold"] = self.threshold.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AsCodeReferentialIntegrityMonitorParamsDtoV2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "kind": obj.get("kind"),
                "left": (
                    AsCodeReferentialIntegrityLeftDtoV2.from_dict(obj["left"]) if obj.get("left") is not None else None
                ),
                "matchType": obj.get("matchType"),
                "right": (
                    AsCodeReferentialIntegrityRightDto.from_dict(obj["right"]) if obj.get("right") is not None else None
                ),
                "threshold": (
                    AsCodeReferentialIntegrityMonitorParamsDtoV2AllOfThreshold.from_dict(obj["threshold"])
                    if obj.get("threshold") is not None
                    else None
                ),
            }
        )
        return _obj
