# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from importlib import import_module
from typing import TYPE_CHECKING, Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from sifflet_sdk.client.models.as_code_calendar_reference_dto import (
    AsCodeCalendarReferenceDto,
)
from typing_extensions import Self

if TYPE_CHECKING:
    from sifflet_sdk.client.models.as_code_dynamic_threshold_dto_v2 import (
        AsCodeDynamicThresholdDtoV2,
    )
    from sifflet_sdk.client.models.as_code_static_threshold_dto_v2 import (
        AsCodeStaticThresholdDtoV2,
    )


class AsCodeThresholdBaseDto(BaseModel):
    """
    AsCodeThresholdBaseDto
    """  # noqa: E501

    excluded_dates: Optional[List[AsCodeCalendarReferenceDto]] = Field(default=None, alias="excludedDates")
    kind: StrictStr
    value_mode: Optional[StrictStr] = Field(default=None, alias="valueMode")
    __properties: ClassVar[List[str]] = ["excludedDates", "kind", "valueMode"]

    @field_validator("kind")
    def kind_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["Static", "Dynamic"]):
            raise ValueError("must be one of enum values ('Static', 'Dynamic')")
        return value

    @field_validator("value_mode")
    def value_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["Count", "Percentage"]):
            raise ValueError("must be one of enum values ('Count', 'Percentage')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = "kind"

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        "AsCodeDynamicThresholdDtoV2": "AsCodeDynamicThresholdDtoV2",
        "AsCodeStaticThresholdDtoV2": "AsCodeStaticThresholdDtoV2",
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Union[AsCodeDynamicThresholdDtoV2, AsCodeStaticThresholdDtoV2]]:
        """Create an instance of AsCodeThresholdBaseDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in excluded_dates (list)
        _items = []
        if self.excluded_dates:
            for _item_excluded_dates in self.excluded_dates:
                if _item_excluded_dates:
                    _items.append(_item_excluded_dates.to_dict())
            _dict["excludedDates"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[Union[AsCodeDynamicThresholdDtoV2, AsCodeStaticThresholdDtoV2]]:
        """Create an instance of AsCodeThresholdBaseDto from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type == "AsCodeDynamicThresholdDtoV2":
            return import_module(
                "sifflet_sdk.client.models.as_code_dynamic_threshold_dto_v2"
            ).AsCodeDynamicThresholdDtoV2.from_dict(obj)
        if object_type == "AsCodeStaticThresholdDtoV2":
            return import_module(
                "sifflet_sdk.client.models.as_code_static_threshold_dto_v2"
            ).AsCodeStaticThresholdDtoV2.from_dict(obj)

        raise ValueError(
            "AsCodeThresholdBaseDto failed to lookup discriminator value from "
            + json.dumps(obj)
            + ". Discriminator property name: "
            + cls.__discriminator_property_name
            + ", mapping: "
            + json.dumps(cls.__discriminator_value_class_map)
        )
