# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from sifflet_sdk.client.models.simple_duration import SimpleDuration
from typing_extensions import Self


class AsCodeTimeWindowClauseWithoutFieldDtoV2(BaseModel):
    """
    AsCodeTimeWindowClauseWithoutFieldDtoV2
    """  # noqa: E501

    delta_querying: Optional[SimpleDuration] = Field(default=None, alias="deltaQuerying")
    first_run: Optional[SimpleDuration] = Field(default=None, alias="firstRun")
    frequency: Optional[SimpleDuration] = None
    offset: Optional[SimpleDuration] = None
    offset_periods: Optional[StrictInt] = Field(default=None, alias="offsetPeriods")
    rolling_time_window: Optional[SimpleDuration] = Field(default=None, alias="rollingTimeWindow")
    __properties: ClassVar[List[str]] = [
        "deltaQuerying",
        "firstRun",
        "frequency",
        "offset",
        "offsetPeriods",
        "rollingTimeWindow",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AsCodeTimeWindowClauseWithoutFieldDtoV2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of delta_querying
        if self.delta_querying:
            _dict["deltaQuerying"] = self.delta_querying.to_dict()
        # override the default output from pydantic by calling `to_dict()` of first_run
        if self.first_run:
            _dict["firstRun"] = self.first_run.to_dict()
        # override the default output from pydantic by calling `to_dict()` of frequency
        if self.frequency:
            _dict["frequency"] = self.frequency.to_dict()
        # override the default output from pydantic by calling `to_dict()` of offset
        if self.offset:
            _dict["offset"] = self.offset.to_dict()
        # override the default output from pydantic by calling `to_dict()` of rolling_time_window
        if self.rolling_time_window:
            _dict["rollingTimeWindow"] = self.rolling_time_window.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AsCodeTimeWindowClauseWithoutFieldDtoV2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "deltaQuerying": (
                    SimpleDuration.from_dict(obj["deltaQuerying"]) if obj.get("deltaQuerying") is not None else None
                ),
                "firstRun": SimpleDuration.from_dict(obj["firstRun"]) if obj.get("firstRun") is not None else None,
                "frequency": SimpleDuration.from_dict(obj["frequency"]) if obj.get("frequency") is not None else None,
                "offset": SimpleDuration.from_dict(obj["offset"]) if obj.get("offset") is not None else None,
                "offsetPeriods": obj.get("offsetPeriods"),
                "rollingTimeWindow": (
                    SimpleDuration.from_dict(obj["rollingTimeWindow"])
                    if obj.get("rollingTimeWindow") is not None
                    else None
                ),
            }
        )
        return _obj
