# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.asset_details_dto import AssetDetailsDto
from sifflet_sdk.client.models.dag_details_dto import DagDetailsDto
from sifflet_sdk.client.models.dataset_details_dto import DatasetDetailsDto
from sifflet_sdk.client.models.declared_asset_details_dto import DeclaredAssetDetailsDto
from typing_extensions import Literal, Self

ASSETOVERVIEWDETAILS_ONE_OF_SCHEMAS = [
    "AssetDetailsDto",
    "DagDetailsDto",
    "DatasetDetailsDto",
    "DeclaredAssetDetailsDto",
]


class AssetOverviewDetails(BaseModel):
    """
    AssetOverviewDetails
    """

    # data type: AssetDetailsDto
    oneof_schema_1_validator: Optional[AssetDetailsDto] = None
    # data type: DagDetailsDto
    oneof_schema_2_validator: Optional[DagDetailsDto] = None
    # data type: DatasetDetailsDto
    oneof_schema_3_validator: Optional[DatasetDetailsDto] = None
    # data type: DeclaredAssetDetailsDto
    oneof_schema_4_validator: Optional[DeclaredAssetDetailsDto] = None
    actual_instance: Optional[Union[AssetDetailsDto, DagDetailsDto, DatasetDetailsDto, DeclaredAssetDetailsDto]] = None
    one_of_schemas: Set[str] = {"AssetDetailsDto", "DagDetailsDto", "DatasetDetailsDto", "DeclaredAssetDetailsDto"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = AssetOverviewDetails.model_construct()
        error_messages = []
        match = 0
        # validate data type: AssetDetailsDto
        if not isinstance(v, AssetDetailsDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AssetDetailsDto`")
        else:
            match += 1
        # validate data type: DagDetailsDto
        if not isinstance(v, DagDetailsDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DagDetailsDto`")
        else:
            match += 1
        # validate data type: DatasetDetailsDto
        if not isinstance(v, DatasetDetailsDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DatasetDetailsDto`")
        else:
            match += 1
        # validate data type: DeclaredAssetDetailsDto
        if not isinstance(v, DeclaredAssetDetailsDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeclaredAssetDetailsDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in AssetOverviewDetails with oneOf schemas: AssetDetailsDto, DagDetailsDto, DatasetDetailsDto, DeclaredAssetDetailsDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in AssetOverviewDetails with oneOf schemas: AssetDetailsDto, DagDetailsDto, DatasetDetailsDto, DeclaredAssetDetailsDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AssetDetailsDto
        try:
            instance.actual_instance = AssetDetailsDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DagDetailsDto
        try:
            instance.actual_instance = DagDetailsDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DatasetDetailsDto
        try:
            instance.actual_instance = DatasetDetailsDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DeclaredAssetDetailsDto
        try:
            instance.actual_instance = DeclaredAssetDetailsDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into AssetOverviewDetails with oneOf schemas: AssetDetailsDto, DagDetailsDto, DatasetDetailsDto, DeclaredAssetDetailsDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into AssetOverviewDetails with oneOf schemas: AssetDetailsDto, DagDetailsDto, DatasetDetailsDto, DeclaredAssetDetailsDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[Union[Dict[str, Any], AssetDetailsDto, DagDetailsDto, DatasetDetailsDto, DeclaredAssetDetailsDto]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
