# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Self


class AssetPatchDto(BaseModel):
    """
    AssetPatchDto
    """  # noqa: E501

    custom_metadata_entries_operation: Optional[StrictStr] = Field(default=None, alias="customMetadataEntriesOperation")
    custom_metadata_entry_ids: Optional[List[StrictStr]] = Field(default=None, alias="customMetadataEntryIds")
    description: Optional[StrictStr] = None
    owner_ids: Optional[List[StrictStr]] = Field(default=None, alias="ownerIds")
    tag_ids: Optional[List[StrictStr]] = Field(default=None, alias="tagIds")
    term_ids: Optional[List[StrictStr]] = Field(default=None, alias="termIds")
    __properties: ClassVar[List[str]] = [
        "customMetadataEntriesOperation",
        "customMetadataEntryIds",
        "description",
        "ownerIds",
        "tagIds",
        "termIds",
    ]

    @field_validator("custom_metadata_entries_operation")
    def custom_metadata_entries_operation_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["ADD", "REPLACE"]):
            raise ValueError("must be one of enum values ('ADD', 'REPLACE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssetPatchDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssetPatchDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "customMetadataEntriesOperation": obj.get("customMetadataEntriesOperation"),
                "customMetadataEntryIds": obj.get("customMetadataEntryIds"),
                "description": obj.get("description"),
                "ownerIds": obj.get("ownerIds"),
                "tagIds": obj.get("tagIds"),
                "termIds": obj.get("termIds"),
            }
        )
        return _obj
