# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictBool,
    StrictInt,
    StrictStr,
    field_validator,
)
from typing_extensions import Self


class AssetSearchCriteria(BaseModel):
    """
    AssetSearchCriteria
    """  # noqa: E501

    asset_filter_type: Optional[List[StrictStr]] = Field(default=None, alias="assetFilterType")
    custom_metadata_entry: Optional[List[StrictStr]] = Field(default=None, alias="customMetadataEntry")
    data_product: Optional[List[StrictStr]] = Field(default=None, alias="dataProduct")
    datasource: Optional[List[StrictStr]] = None
    domain: Optional[StrictStr] = None
    health_status: Optional[List[StrictStr]] = Field(default=None, alias="healthStatus")
    ingestion: Optional[List[StrictStr]] = None
    items_per_page: Optional[StrictInt] = Field(default=25, alias="itemsPerPage")
    owner: Optional[List[StrictStr]] = None
    page: Optional[StrictInt] = 0
    search_in_fields_and_descriptions: Optional[StrictBool] = Field(default=None, alias="searchInFieldsAndDescriptions")
    sort: Optional[List[StrictStr]] = None
    tag: Optional[List[StrictStr]] = None
    term: Optional[List[StrictStr]] = None
    text_search: Optional[StrictStr] = Field(default=None, alias="textSearch")
    urn: Optional[List[StrictStr]] = None
    usage: Optional[List[StrictStr]] = None
    usage_qualification: Optional[List[StrictStr]] = Field(default=None, alias="usageQualification")
    __properties: ClassVar[List[str]] = [
        "assetFilterType",
        "customMetadataEntry",
        "dataProduct",
        "datasource",
        "domain",
        "healthStatus",
        "ingestion",
        "itemsPerPage",
        "owner",
        "page",
        "searchInFieldsAndDescriptions",
        "sort",
        "tag",
        "term",
        "textSearch",
        "urn",
        "usage",
        "usageQualification",
    ]

    @field_validator("health_status")
    def health_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(["CRITICAL", "AT_RISK", "HEALTHY", "UNMONITORED", "NOT_SUPPORTED"]):
                raise ValueError(
                    "each list item must be one of ('CRITICAL', 'AT_RISK', 'HEALTHY', 'UNMONITORED', 'NOT_SUPPORTED')"
                )
        return value

    @field_validator("ingestion")
    def ingestion_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(["DECLARATIVE", "SIFFLET_SOURCED"]):
                raise ValueError("each list item must be one of ('DECLARATIVE', 'SIFFLET_SOURCED')")
        return value

    @field_validator("usage")
    def usage_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(["UNSUPPORTED", "LOW", "MEDIUM", "HIGH"]):
                raise ValueError("each list item must be one of ('UNSUPPORTED', 'LOW', 'MEDIUM', 'HIGH')")
        return value

    @field_validator("usage_qualification")
    def usage_qualification_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(["UNSUPPORTED", "LOW", "MEDIUM", "HIGH"]):
                raise ValueError("each list item must be one of ('UNSUPPORTED', 'LOW', 'MEDIUM', 'HIGH')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssetSearchCriteria from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssetSearchCriteria from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "assetFilterType": obj.get("assetFilterType"),
                "customMetadataEntry": obj.get("customMetadataEntry"),
                "dataProduct": obj.get("dataProduct"),
                "datasource": obj.get("datasource"),
                "domain": obj.get("domain"),
                "healthStatus": obj.get("healthStatus"),
                "ingestion": obj.get("ingestion"),
                "itemsPerPage": obj.get("itemsPerPage") if obj.get("itemsPerPage") is not None else 25,
                "owner": obj.get("owner"),
                "page": obj.get("page") if obj.get("page") is not None else 0,
                "searchInFieldsAndDescriptions": obj.get("searchInFieldsAndDescriptions"),
                "sort": obj.get("sort"),
                "tag": obj.get("tag"),
                "term": obj.get("term"),
                "textSearch": obj.get("textSearch"),
                "urn": obj.get("urn"),
                "usage": obj.get("usage"),
                "usageQualification": obj.get("usageQualification"),
            }
        )
        return _obj
