# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictBool,
    StrictStr,
    field_validator,
)
from typing_extensions import Self


class AssetSelectionDto(BaseModel):
    """
    AssetSelectionDto
    """  # noqa: E501

    asset_type: StrictStr = Field(alias="assetType")
    children: List[AssetSelectionDto]
    id: StrictStr
    included: Optional[StrictBool] = None
    name: StrictStr
    new_children_included: Optional[StrictBool] = Field(default=None, alias="newChildrenIncluded")
    __properties: ClassVar[List[str]] = ["assetType", "children", "id", "included", "name", "newChildrenIncluded"]

    @field_validator("asset_type")
    def asset_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(
            [
                "ACCOUNT",
                "ENVIRONMENT",
                "DATABASE",
                "SCHEMA",
                "PROJECT",
                "DATASET",
                "CLUSTER",
                "CATALOG",
                "WORKSPACE",
                "SPACE",
                "FOLDER",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('ACCOUNT', 'ENVIRONMENT', 'DATABASE', 'SCHEMA', 'PROJECT', 'DATASET', 'CLUSTER', 'CATALOG', 'WORKSPACE', 'SPACE', 'FOLDER')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssetSelectionDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in children (list)
        _items = []
        if self.children:
            for _item_children in self.children:
                if _item_children:
                    _items.append(_item_children.to_dict())
            _dict["children"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssetSelectionDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "assetType": obj.get("assetType"),
                "children": (
                    [AssetSelectionDto.from_dict(_item) for _item in obj["children"]]
                    if obj.get("children") is not None
                    else None
                ),
                "id": obj.get("id"),
                "included": obj.get("included"),
                "name": obj.get("name"),
                "newChildrenIncluded": obj.get("newChildrenIncluded"),
            }
        )
        return _obj


# TODO: Rewrite to not use raise_errors
AssetSelectionDto.model_rebuild(raise_errors=False)
