# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from sifflet_sdk.client.models.base_search_filter_dto_children_inner import (
    BaseSearchFilterDtoChildrenInner,
)
from typing_extensions import Self


class BaseSearchFilterDto(BaseModel):
    """
    BaseSearchFilterDto
    """  # noqa: E501

    children: Optional[List[BaseSearchFilterDtoChildrenInner]] = None
    query: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["children", "query", "type"]

    @field_validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "ASSET_TYPE",
                "PLATFORM",
                "HEALTH_STATUS",
                "TAG",
                "TERM",
                "USAGE",
                "RULE_STATUS",
                "CRITICALITY",
                "RULE_TEMPLATE_NAME",
                "DATASET",
                "OWNER",
                "ASSET_INGESTION",
                "TECHNOLOGY",
                "CREATED_BY",
                "CREATION_METHOD",
                "AS_CODE_WORKSPACE",
                "CUSTOM_METADATA",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('ASSET_TYPE', 'PLATFORM', 'HEALTH_STATUS', 'TAG', 'TERM', 'USAGE', 'RULE_STATUS', 'CRITICALITY', 'RULE_TEMPLATE_NAME', 'DATASET', 'OWNER', 'ASSET_INGESTION', 'TECHNOLOGY', 'CREATED_BY', 'CREATION_METHOD', 'AS_CODE_WORKSPACE', 'CUSTOM_METADATA')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BaseSearchFilterDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in children (list)
        _items = []
        if self.children:
            for _item_children in self.children:
                if _item_children:
                    _items.append(_item_children.to_dict())
            _dict["children"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BaseSearchFilterDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "children": (
                    [BaseSearchFilterDtoChildrenInner.from_dict(_item) for _item in obj["children"]]
                    if obj.get("children") is not None
                    else None
                ),
                "query": obj.get("query"),
                "type": obj.get("type"),
            }
        )
        return _obj
