# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.get_all_datasource_params_type200_response_inner import (
    GetAllDatasourceParamsType200ResponseInner,
)
from typing_extensions import Self


class CreateDatasourceBatchDto(BaseModel):
    """
    CreateDatasourceBatchDto
    """  # noqa: E501

    cron_expression: Optional[StrictStr] = Field(default=None, alias="cronExpression")
    description: Optional[StrictStr] = None
    name: StrictStr
    params: GetAllDatasourceParamsType200ResponseInner
    schemas_to_create: List[StrictStr] = Field(alias="schemasToCreate")
    secret_id: Optional[StrictStr] = Field(default=None, alias="secretId")
    tags: Optional[List[StrictStr]] = None
    type: StrictStr
    __properties: ClassVar[List[str]] = [
        "cronExpression",
        "description",
        "name",
        "params",
        "schemasToCreate",
        "secretId",
        "tags",
        "type",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateDatasourceBatchDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of params
        if self.params:
            _dict["params"] = self.params.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateDatasourceBatchDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "cronExpression": obj.get("cronExpression"),
                "description": obj.get("description"),
                "name": obj.get("name"),
                "params": (
                    GetAllDatasourceParamsType200ResponseInner.from_dict(obj["params"])
                    if obj.get("params") is not None
                    else None
                ),
                "schemasToCreate": obj.get("schemasToCreate"),
                "secretId": obj.get("secretId"),
                "tags": obj.get("tags"),
                "type": obj.get("type"),
            }
        )
        return _obj
