# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.create_datasource_job_dto import CreateDatasourceJobDto
from sifflet_sdk.client.models.create_debug_job_dto import CreateDebugJobDto
from sifflet_sdk.client.models.create_job_dto import CreateJobDto
from typing_extensions import Literal, Self

CREATESIFFLETAGENTJOBREQUEST_ONE_OF_SCHEMAS = ["CreateDatasourceJobDto", "CreateDebugJobDto", "CreateJobDto"]


class CreateSiffletAgentJobRequest(BaseModel):
    """
    CreateSiffletAgentJobRequest
    """

    # data type: CreateJobDto
    oneof_schema_1_validator: Optional[CreateJobDto] = None
    # data type: CreateDatasourceJobDto
    oneof_schema_2_validator: Optional[CreateDatasourceJobDto] = None
    # data type: CreateDebugJobDto
    oneof_schema_3_validator: Optional[CreateDebugJobDto] = None
    actual_instance: Optional[Union[CreateDatasourceJobDto, CreateDebugJobDto, CreateJobDto]] = None
    one_of_schemas: Set[str] = {"CreateDatasourceJobDto", "CreateDebugJobDto", "CreateJobDto"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = CreateSiffletAgentJobRequest.model_construct()
        error_messages = []
        match = 0
        # validate data type: CreateJobDto
        if not isinstance(v, CreateJobDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateJobDto`")
        else:
            match += 1
        # validate data type: CreateDatasourceJobDto
        if not isinstance(v, CreateDatasourceJobDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateDatasourceJobDto`")
        else:
            match += 1
        # validate data type: CreateDebugJobDto
        if not isinstance(v, CreateDebugJobDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateDebugJobDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in CreateSiffletAgentJobRequest with oneOf schemas: CreateDatasourceJobDto, CreateDebugJobDto, CreateJobDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in CreateSiffletAgentJobRequest with oneOf schemas: CreateDatasourceJobDto, CreateDebugJobDto, CreateJobDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `CreateDatasourceJobDto`
        if _data_type == "DATASOURCE_JOB":
            instance.actual_instance = CreateDatasourceJobDto.from_json(json_str)
            return instance

        # check if data type is `CreateDebugJobDto`
        if _data_type == "DEBUG_JOB":
            instance.actual_instance = CreateDebugJobDto.from_json(json_str)
            return instance

        # check if data type is `CreateDatasourceJobDto`
        if _data_type == "CreateDatasourceJobDto":
            instance.actual_instance = CreateDatasourceJobDto.from_json(json_str)
            return instance

        # check if data type is `CreateDebugJobDto`
        if _data_type == "CreateDebugJobDto":
            instance.actual_instance = CreateDebugJobDto.from_json(json_str)
            return instance

        # check if data type is `CreateJobDto`
        if _data_type == "CreateJobDto":
            instance.actual_instance = CreateJobDto.from_json(json_str)
            return instance

        # deserialize data into CreateJobDto
        try:
            instance.actual_instance = CreateJobDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into CreateDatasourceJobDto
        try:
            instance.actual_instance = CreateDatasourceJobDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into CreateDebugJobDto
        try:
            instance.actual_instance = CreateDebugJobDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into CreateSiffletAgentJobRequest with oneOf schemas: CreateDatasourceJobDto, CreateDebugJobDto, CreateJobDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into CreateSiffletAgentJobRequest with oneOf schemas: CreateDatasourceJobDto, CreateDebugJobDto, CreateJobDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], CreateDatasourceJobDto, CreateDebugJobDto, CreateJobDto]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
