# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from sifflet_sdk.client.models.datapoint_qualification_dto_provider import (
    DatapointQualificationDtoProvider,
)
from sifflet_sdk.client.models.group_identifier_dto import GroupIdentifierDto
from typing_extensions import Self


class DatapointQualificationLightDto(BaseModel):
    """
    DatapointQualificationLightDto
    """  # noqa: E501

    comment: Optional[StrictStr] = None
    created_by_provider: DatapointQualificationDtoProvider = Field(alias="createdByProvider")
    created_date: Optional[StrictInt] = Field(default=None, alias="createdDate")
    group: Optional[GroupIdentifierDto] = None
    id: StrictStr
    last_modified_date: Optional[StrictInt] = Field(default=None, alias="lastModifiedDate")
    modified_by_provider: DatapointQualificationDtoProvider = Field(alias="modifiedByProvider")
    qualification: StrictStr
    __properties: ClassVar[List[str]] = [
        "comment",
        "createdByProvider",
        "createdDate",
        "group",
        "id",
        "lastModifiedDate",
        "modifiedByProvider",
        "qualification",
    ]

    @field_validator("qualification")
    def qualification_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(
            [
                "NO_QUALIFICATION",
                "FALSE_NEGATIVE",
                "FALSE_POSITIVE",
                "FIXED",
                "NO_ACTION_NEEDED",
                "UNDER_INVESTIGATION",
                "REVIEWED",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('NO_QUALIFICATION', 'FALSE_NEGATIVE', 'FALSE_POSITIVE', 'FIXED', 'NO_ACTION_NEEDED', 'UNDER_INVESTIGATION', 'REVIEWED')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DatapointQualificationLightDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of created_by_provider
        if self.created_by_provider:
            _dict["createdByProvider"] = self.created_by_provider.to_dict()
        # override the default output from pydantic by calling `to_dict()` of group
        if self.group:
            _dict["group"] = self.group.to_dict()
        # override the default output from pydantic by calling `to_dict()` of modified_by_provider
        if self.modified_by_provider:
            _dict["modifiedByProvider"] = self.modified_by_provider.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DatapointQualificationLightDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "comment": obj.get("comment"),
                "createdByProvider": (
                    DatapointQualificationDtoProvider.from_dict(obj["createdByProvider"])
                    if obj.get("createdByProvider") is not None
                    else None
                ),
                "createdDate": obj.get("createdDate"),
                "group": GroupIdentifierDto.from_dict(obj["group"]) if obj.get("group") is not None else None,
                "id": obj.get("id"),
                "lastModifiedDate": obj.get("lastModifiedDate"),
                "modifiedByProvider": (
                    DatapointQualificationDtoProvider.from_dict(obj["modifiedByProvider"])
                    if obj.get("modifiedByProvider") is not None
                    else None
                ),
                "qualification": obj.get("qualification"),
            }
        )
        return _obj
