# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from sifflet_sdk.client.models.dbt_transformation_information_dto import (
    DbtTransformationInformationDto,
)
from typing_extensions import Self


class DatasetGeneratingTransformationDto(BaseModel):
    """
    DatasetGeneratingTransformationDto
    """  # noqa: E501

    transformation_datasource_id: Optional[StrictStr] = Field(default=None, alias="transformationDatasourceId")
    transformation_datasource_last_refresh: Optional[StrictInt] = Field(
        default=None, alias="transformationDatasourceLastRefresh"
    )
    transformation_datasource_name: Optional[StrictStr] = Field(default=None, alias="transformationDatasourceName")
    transformation_description: Optional[StrictStr] = Field(default=None, alias="transformationDescription")
    transformation_id: Optional[StrictStr] = Field(default=None, alias="transformationId")
    transformation_information_dto: Optional[DbtTransformationInformationDto] = Field(
        default=None, alias="transformationInformationDto"
    )
    transformation_name: Optional[StrictStr] = Field(default=None, alias="transformationName")
    transformation_type: Optional[StrictStr] = Field(default=None, alias="transformationType")
    __properties: ClassVar[List[str]] = [
        "transformationDatasourceId",
        "transformationDatasourceLastRefresh",
        "transformationDatasourceName",
        "transformationDescription",
        "transformationId",
        "transformationInformationDto",
        "transformationName",
        "transformationType",
    ]

    @field_validator("transformation_type")
    def transformation_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["FIVETRAN_CONNECTOR", "DBT_MODEL", "DBT_SEED"]):
            raise ValueError("must be one of enum values ('FIVETRAN_CONNECTOR', 'DBT_MODEL', 'DBT_SEED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DatasetGeneratingTransformationDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of transformation_information_dto
        if self.transformation_information_dto:
            _dict["transformationInformationDto"] = self.transformation_information_dto.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DatasetGeneratingTransformationDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "transformationDatasourceId": obj.get("transformationDatasourceId"),
                "transformationDatasourceLastRefresh": obj.get("transformationDatasourceLastRefresh"),
                "transformationDatasourceName": obj.get("transformationDatasourceName"),
                "transformationDescription": obj.get("transformationDescription"),
                "transformationId": obj.get("transformationId"),
                "transformationInformationDto": (
                    DbtTransformationInformationDto.from_dict(obj["transformationInformationDto"])
                    if obj.get("transformationInformationDto") is not None
                    else None
                ),
                "transformationName": obj.get("transformationName"),
                "transformationType": obj.get("transformationType"),
            }
        )
        return _obj
