# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Self


class DbtImpactAnalysisSearchCriteriaDto(BaseModel):
    """
    DbtImpactAnalysisSearchCriteriaDto
    """  # noqa: E501

    dbt_model_name: Optional[StrictStr] = Field(default=None, alias="dbtModelName")
    dbt_project_name: Optional[StrictStr] = Field(default=None, alias="dbtProjectName")
    filtered_asset_types: Optional[List[StrictStr]] = Field(default=None, alias="filteredAssetTypes")
    filtered_tags: Optional[List[StrictStr]] = Field(default=None, alias="filteredTags")
    pull_request_url: Optional[StrictStr] = Field(default=None, alias="pullRequestUrl")
    __properties: ClassVar[List[str]] = [
        "dbtModelName",
        "dbtProjectName",
        "filteredAssetTypes",
        "filteredTags",
        "pullRequestUrl",
    ]

    @field_validator("filtered_asset_types")
    def filtered_asset_types_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(["DATASET", "DASHBOARD"]):
                raise ValueError("each list item must be one of ('DATASET', 'DASHBOARD')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DbtImpactAnalysisSearchCriteriaDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DbtImpactAnalysisSearchCriteriaDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "dbtModelName": obj.get("dbtModelName"),
                "dbtProjectName": obj.get("dbtProjectName"),
                "filteredAssetTypes": obj.get("filteredAssetTypes"),
                "filteredTags": obj.get("filteredTags"),
                "pullRequestUrl": obj.get("pullRequestUrl"),
            }
        )
        return _obj
