# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.access_token_provider_dto import AccessTokenProviderDto
from sifflet_sdk.client.models.datasource_provider_dto import DatasourceProviderDto
from sifflet_sdk.client.models.generic_provider_dto import GenericProviderDto
from sifflet_sdk.client.models.user_provider_dto import UserProviderDto
from typing_extensions import Literal, Self

DECLAREDASSETDETAILSDTOALLOFCREATEDBY_ONE_OF_SCHEMAS = [
    "AccessTokenProviderDto",
    "DatasourceProviderDto",
    "GenericProviderDto",
    "UserProviderDto",
]


class DeclaredAssetDetailsDtoAllOfCreatedBy(BaseModel):
    """
    DeclaredAssetDetailsDtoAllOfCreatedBy
    """

    # data type: AccessTokenProviderDto
    oneof_schema_1_validator: Optional[AccessTokenProviderDto] = None
    # data type: DatasourceProviderDto
    oneof_schema_2_validator: Optional[DatasourceProviderDto] = None
    # data type: GenericProviderDto
    oneof_schema_3_validator: Optional[GenericProviderDto] = None
    # data type: UserProviderDto
    oneof_schema_4_validator: Optional[UserProviderDto] = None
    actual_instance: Optional[
        Union[AccessTokenProviderDto, DatasourceProviderDto, GenericProviderDto, UserProviderDto]
    ] = None
    one_of_schemas: Set[str] = {
        "AccessTokenProviderDto",
        "DatasourceProviderDto",
        "GenericProviderDto",
        "UserProviderDto",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = DeclaredAssetDetailsDtoAllOfCreatedBy.model_construct()
        error_messages = []
        match = 0
        # validate data type: AccessTokenProviderDto
        if not isinstance(v, AccessTokenProviderDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AccessTokenProviderDto`")
        else:
            match += 1
        # validate data type: DatasourceProviderDto
        if not isinstance(v, DatasourceProviderDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DatasourceProviderDto`")
        else:
            match += 1
        # validate data type: GenericProviderDto
        if not isinstance(v, GenericProviderDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GenericProviderDto`")
        else:
            match += 1
        # validate data type: UserProviderDto
        if not isinstance(v, UserProviderDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UserProviderDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in DeclaredAssetDetailsDtoAllOfCreatedBy with oneOf schemas: AccessTokenProviderDto, DatasourceProviderDto, GenericProviderDto, UserProviderDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in DeclaredAssetDetailsDtoAllOfCreatedBy with oneOf schemas: AccessTokenProviderDto, DatasourceProviderDto, GenericProviderDto, UserProviderDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `AccessTokenProviderDto`
        if _data_type == "ACCESS_TOKEN":
            instance.actual_instance = AccessTokenProviderDto.from_json(json_str)
            return instance

        # check if data type is `DatasourceProviderDto`
        if _data_type == "DATASOURCE":
            instance.actual_instance = DatasourceProviderDto.from_json(json_str)
            return instance

        # check if data type is `GenericProviderDto`
        if _data_type == "GENERIC":
            instance.actual_instance = GenericProviderDto.from_json(json_str)
            return instance

        # check if data type is `UserProviderDto`
        if _data_type == "USER":
            instance.actual_instance = UserProviderDto.from_json(json_str)
            return instance

        # check if data type is `AccessTokenProviderDto`
        if _data_type == "AccessTokenProviderDto":
            instance.actual_instance = AccessTokenProviderDto.from_json(json_str)
            return instance

        # check if data type is `DatasourceProviderDto`
        if _data_type == "DatasourceProviderDto":
            instance.actual_instance = DatasourceProviderDto.from_json(json_str)
            return instance

        # check if data type is `GenericProviderDto`
        if _data_type == "GenericProviderDto":
            instance.actual_instance = GenericProviderDto.from_json(json_str)
            return instance

        # check if data type is `UserProviderDto`
        if _data_type == "UserProviderDto":
            instance.actual_instance = UserProviderDto.from_json(json_str)
            return instance

        # deserialize data into AccessTokenProviderDto
        try:
            instance.actual_instance = AccessTokenProviderDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DatasourceProviderDto
        try:
            instance.actual_instance = DatasourceProviderDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into GenericProviderDto
        try:
            instance.actual_instance = GenericProviderDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UserProviderDto
        try:
            instance.actual_instance = UserProviderDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into DeclaredAssetDetailsDtoAllOfCreatedBy with oneOf schemas: AccessTokenProviderDto, DatasourceProviderDto, GenericProviderDto, UserProviderDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into DeclaredAssetDetailsDtoAllOfCreatedBy with oneOf schemas: AccessTokenProviderDto, DatasourceProviderDto, GenericProviderDto, UserProviderDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[Dict[str, Any], AccessTokenProviderDto, DatasourceProviderDto, GenericProviderDto, UserProviderDto]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
