# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.dag_asset_overview import DagAssetOverview
from sifflet_sdk.client.models.dashboard_asset_overview import DashboardAssetOverview
from sifflet_sdk.client.models.dataset_asset_overview import DatasetAssetOverview
from sifflet_sdk.client.models.declared_asset_overview import DeclaredAssetOverview
from sifflet_sdk.client.models.transformation_asset_overview import (
    TransformationAssetOverview,
)
from typing_extensions import Literal, Self

GETASSETOVERVIEWBYURN200RESPONSE_ONE_OF_SCHEMAS = [
    "DagAssetOverview",
    "DashboardAssetOverview",
    "DatasetAssetOverview",
    "DeclaredAssetOverview",
    "TransformationAssetOverview",
]


class GetAssetOverviewByUrn200Response(BaseModel):
    """
    GetAssetOverviewByUrn200Response
    """

    # data type: DagAssetOverview
    oneof_schema_1_validator: Optional[DagAssetOverview] = None
    # data type: DashboardAssetOverview
    oneof_schema_2_validator: Optional[DashboardAssetOverview] = None
    # data type: DatasetAssetOverview
    oneof_schema_3_validator: Optional[DatasetAssetOverview] = None
    # data type: DeclaredAssetOverview
    oneof_schema_4_validator: Optional[DeclaredAssetOverview] = None
    # data type: TransformationAssetOverview
    oneof_schema_5_validator: Optional[TransformationAssetOverview] = None
    actual_instance: Optional[
        Union[
            DagAssetOverview,
            DashboardAssetOverview,
            DatasetAssetOverview,
            DeclaredAssetOverview,
            TransformationAssetOverview,
        ]
    ] = None
    one_of_schemas: Set[str] = {
        "DagAssetOverview",
        "DashboardAssetOverview",
        "DatasetAssetOverview",
        "DeclaredAssetOverview",
        "TransformationAssetOverview",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = GetAssetOverviewByUrn200Response.model_construct()
        error_messages = []
        match = 0
        # validate data type: DagAssetOverview
        if not isinstance(v, DagAssetOverview):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DagAssetOverview`")
        else:
            match += 1
        # validate data type: DashboardAssetOverview
        if not isinstance(v, DashboardAssetOverview):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DashboardAssetOverview`")
        else:
            match += 1
        # validate data type: DatasetAssetOverview
        if not isinstance(v, DatasetAssetOverview):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DatasetAssetOverview`")
        else:
            match += 1
        # validate data type: DeclaredAssetOverview
        if not isinstance(v, DeclaredAssetOverview):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeclaredAssetOverview`")
        else:
            match += 1
        # validate data type: TransformationAssetOverview
        if not isinstance(v, TransformationAssetOverview):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TransformationAssetOverview`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in GetAssetOverviewByUrn200Response with oneOf schemas: DagAssetOverview, DashboardAssetOverview, DatasetAssetOverview, DeclaredAssetOverview, TransformationAssetOverview. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in GetAssetOverviewByUrn200Response with oneOf schemas: DagAssetOverview, DashboardAssetOverview, DatasetAssetOverview, DeclaredAssetOverview, TransformationAssetOverview. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into DagAssetOverview
        try:
            instance.actual_instance = DagAssetOverview.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DashboardAssetOverview
        try:
            instance.actual_instance = DashboardAssetOverview.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DatasetAssetOverview
        try:
            instance.actual_instance = DatasetAssetOverview.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DeclaredAssetOverview
        try:
            instance.actual_instance = DeclaredAssetOverview.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TransformationAssetOverview
        try:
            instance.actual_instance = TransformationAssetOverview.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into GetAssetOverviewByUrn200Response with oneOf schemas: DagAssetOverview, DashboardAssetOverview, DatasetAssetOverview, DeclaredAssetOverview, TransformationAssetOverview. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into GetAssetOverviewByUrn200Response with oneOf schemas: DagAssetOverview, DashboardAssetOverview, DatasetAssetOverview, DeclaredAssetOverview, TransformationAssetOverview. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[
            Dict[str, Any],
            DagAssetOverview,
            DashboardAssetOverview,
            DatasetAssetOverview,
            DeclaredAssetOverview,
            TransformationAssetOverview,
        ]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
