# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.get_custom_metadata_entry_label_value_response_dto import (
    GetCustomMetadataEntryLabelValueResponseDto,
)
from sifflet_sdk.client.models.get_custom_metadata_entry_string_value_response_dto import (
    GetCustomMetadataEntryStringValueResponseDto,
)
from sifflet_sdk.client.models.get_custom_metadata_entry_user_value_response_dto import (
    GetCustomMetadataEntryUserValueResponseDto,
)
from typing_extensions import Literal, Self

GETCUSTOMMETADATAENTRY200RESPONSE_ONE_OF_SCHEMAS = [
    "GetCustomMetadataEntryLabelValueResponseDto",
    "GetCustomMetadataEntryStringValueResponseDto",
    "GetCustomMetadataEntryUserValueResponseDto",
]


class GetCustomMetadataEntry200Response(BaseModel):
    """
    GetCustomMetadataEntry200Response
    """

    # data type: GetCustomMetadataEntryLabelValueResponseDto
    oneof_schema_1_validator: Optional[GetCustomMetadataEntryLabelValueResponseDto] = None
    # data type: GetCustomMetadataEntryStringValueResponseDto
    oneof_schema_2_validator: Optional[GetCustomMetadataEntryStringValueResponseDto] = None
    # data type: GetCustomMetadataEntryUserValueResponseDto
    oneof_schema_3_validator: Optional[GetCustomMetadataEntryUserValueResponseDto] = None
    actual_instance: Optional[
        Union[
            GetCustomMetadataEntryLabelValueResponseDto,
            GetCustomMetadataEntryStringValueResponseDto,
            GetCustomMetadataEntryUserValueResponseDto,
        ]
    ] = None
    one_of_schemas: Set[str] = {
        "GetCustomMetadataEntryLabelValueResponseDto",
        "GetCustomMetadataEntryStringValueResponseDto",
        "GetCustomMetadataEntryUserValueResponseDto",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = GetCustomMetadataEntry200Response.model_construct()
        error_messages = []
        match = 0
        # validate data type: GetCustomMetadataEntryLabelValueResponseDto
        if not isinstance(v, GetCustomMetadataEntryLabelValueResponseDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GetCustomMetadataEntryLabelValueResponseDto`")
        else:
            match += 1
        # validate data type: GetCustomMetadataEntryStringValueResponseDto
        if not isinstance(v, GetCustomMetadataEntryStringValueResponseDto):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `GetCustomMetadataEntryStringValueResponseDto`"
            )
        else:
            match += 1
        # validate data type: GetCustomMetadataEntryUserValueResponseDto
        if not isinstance(v, GetCustomMetadataEntryUserValueResponseDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GetCustomMetadataEntryUserValueResponseDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in GetCustomMetadataEntry200Response with oneOf schemas: GetCustomMetadataEntryLabelValueResponseDto, GetCustomMetadataEntryStringValueResponseDto, GetCustomMetadataEntryUserValueResponseDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in GetCustomMetadataEntry200Response with oneOf schemas: GetCustomMetadataEntryLabelValueResponseDto, GetCustomMetadataEntryStringValueResponseDto, GetCustomMetadataEntryUserValueResponseDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `GetCustomMetadataEntryLabelValueResponseDto`
        if _data_type == "GetCustomMetadataEntryLabelValueResponseDto":
            instance.actual_instance = GetCustomMetadataEntryLabelValueResponseDto.from_json(json_str)
            return instance

        # check if data type is `GetCustomMetadataEntryStringValueResponseDto`
        if _data_type == "GetCustomMetadataEntryStringValueResponseDto":
            instance.actual_instance = GetCustomMetadataEntryStringValueResponseDto.from_json(json_str)
            return instance

        # check if data type is `GetCustomMetadataEntryUserValueResponseDto`
        if _data_type == "GetCustomMetadataEntryUserValueResponseDto":
            instance.actual_instance = GetCustomMetadataEntryUserValueResponseDto.from_json(json_str)
            return instance

        # deserialize data into GetCustomMetadataEntryLabelValueResponseDto
        try:
            instance.actual_instance = GetCustomMetadataEntryLabelValueResponseDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into GetCustomMetadataEntryStringValueResponseDto
        try:
            instance.actual_instance = GetCustomMetadataEntryStringValueResponseDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into GetCustomMetadataEntryUserValueResponseDto
        try:
            instance.actual_instance = GetCustomMetadataEntryUserValueResponseDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into GetCustomMetadataEntry200Response with oneOf schemas: GetCustomMetadataEntryLabelValueResponseDto, GetCustomMetadataEntryStringValueResponseDto, GetCustomMetadataEntryUserValueResponseDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into GetCustomMetadataEntry200Response with oneOf schemas: GetCustomMetadataEntryLabelValueResponseDto, GetCustomMetadataEntryStringValueResponseDto, GetCustomMetadataEntryUserValueResponseDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[
            Dict[str, Any],
            GetCustomMetadataEntryLabelValueResponseDto,
            GetCustomMetadataEntryStringValueResponseDto,
            GetCustomMetadataEntryUserValueResponseDto,
        ]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
