# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.alerting_hook_reference_dto import (
    AlertingHookReferenceDto,
)
from sifflet_sdk.client.models.asset_domain_dto import AssetDomainDto
from sifflet_sdk.client.models.create_data_product_request_dto_asset_input import (
    CreateDataProductRequestDtoAssetInput,
)
from sifflet_sdk.client.models.data_product_collaboration_tools_params_dto import (
    DataProductCollaborationToolsParamsDto,
)
from sifflet_sdk.client.models.health_summary import HealthSummary
from sifflet_sdk.client.models.tag_reference_dto import TagReferenceDto
from sifflet_sdk.client.models.user_dto import UserDto
from typing_extensions import Self


class GetDataProductResponseDto(BaseModel):
    """
    GetDataProductResponseDto
    """  # noqa: E501

    asset_input: CreateDataProductRequestDtoAssetInput = Field(alias="assetInput")
    collaboration_tools_params: DataProductCollaborationToolsParamsDto = Field(alias="collaborationToolsParams")
    description: Optional[StrictStr] = None
    domain: AssetDomainDto
    health_summary: HealthSummary = Field(alias="healthSummary")
    id: StrictStr
    mails: List[AlertingHookReferenceDto]
    ms_teams: List[AlertingHookReferenceDto] = Field(alias="msTeams")
    name: StrictStr
    owners: List[UserDto]
    sla: Optional[StrictStr] = None
    slack_channels: List[AlertingHookReferenceDto] = Field(alias="slackChannels")
    tags: List[TagReferenceDto]
    webhooks: List[AlertingHookReferenceDto]
    __properties: ClassVar[List[str]] = [
        "assetInput",
        "collaborationToolsParams",
        "description",
        "domain",
        "healthSummary",
        "id",
        "mails",
        "msTeams",
        "name",
        "owners",
        "sla",
        "slackChannels",
        "tags",
        "webhooks",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetDataProductResponseDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of asset_input
        if self.asset_input:
            _dict["assetInput"] = self.asset_input.to_dict()
        # override the default output from pydantic by calling `to_dict()` of collaboration_tools_params
        if self.collaboration_tools_params:
            _dict["collaborationToolsParams"] = self.collaboration_tools_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of domain
        if self.domain:
            _dict["domain"] = self.domain.to_dict()
        # override the default output from pydantic by calling `to_dict()` of health_summary
        if self.health_summary:
            _dict["healthSummary"] = self.health_summary.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in mails (list)
        _items = []
        if self.mails:
            for _item_mails in self.mails:
                if _item_mails:
                    _items.append(_item_mails.to_dict())
            _dict["mails"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in ms_teams (list)
        _items = []
        if self.ms_teams:
            for _item_ms_teams in self.ms_teams:
                if _item_ms_teams:
                    _items.append(_item_ms_teams.to_dict())
            _dict["msTeams"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in owners (list)
        _items = []
        if self.owners:
            for _item_owners in self.owners:
                if _item_owners:
                    _items.append(_item_owners.to_dict())
            _dict["owners"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in slack_channels (list)
        _items = []
        if self.slack_channels:
            for _item_slack_channels in self.slack_channels:
                if _item_slack_channels:
                    _items.append(_item_slack_channels.to_dict())
            _dict["slackChannels"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tags (list)
        _items = []
        if self.tags:
            for _item_tags in self.tags:
                if _item_tags:
                    _items.append(_item_tags.to_dict())
            _dict["tags"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in webhooks (list)
        _items = []
        if self.webhooks:
            for _item_webhooks in self.webhooks:
                if _item_webhooks:
                    _items.append(_item_webhooks.to_dict())
            _dict["webhooks"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetDataProductResponseDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "assetInput": (
                    CreateDataProductRequestDtoAssetInput.from_dict(obj["assetInput"])
                    if obj.get("assetInput") is not None
                    else None
                ),
                "collaborationToolsParams": (
                    DataProductCollaborationToolsParamsDto.from_dict(obj["collaborationToolsParams"])
                    if obj.get("collaborationToolsParams") is not None
                    else None
                ),
                "description": obj.get("description"),
                "domain": AssetDomainDto.from_dict(obj["domain"]) if obj.get("domain") is not None else None,
                "healthSummary": (
                    HealthSummary.from_dict(obj["healthSummary"]) if obj.get("healthSummary") is not None else None
                ),
                "id": obj.get("id"),
                "mails": (
                    [AlertingHookReferenceDto.from_dict(_item) for _item in obj["mails"]]
                    if obj.get("mails") is not None
                    else None
                ),
                "msTeams": (
                    [AlertingHookReferenceDto.from_dict(_item) for _item in obj["msTeams"]]
                    if obj.get("msTeams") is not None
                    else None
                ),
                "name": obj.get("name"),
                "owners": (
                    [UserDto.from_dict(_item) for _item in obj["owners"]] if obj.get("owners") is not None else None
                ),
                "sla": obj.get("sla"),
                "slackChannels": (
                    [AlertingHookReferenceDto.from_dict(_item) for _item in obj["slackChannels"]]
                    if obj.get("slackChannels") is not None
                    else None
                ),
                "tags": (
                    [TagReferenceDto.from_dict(_item) for _item in obj["tags"]] if obj.get("tags") is not None else None
                ),
                "webhooks": (
                    [AlertingHookReferenceDto.from_dict(_item) for _item in obj["webhooks"]]
                    if obj.get("webhooks") is not None
                    else None
                ),
            }
        )
        return _obj
