# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.ingestion_time_partition_clause import (
    IngestionTimePartitionClause,
)
from sifflet_sdk.client.models.integer_range_partition_clause import (
    IntegerRangePartitionClause,
)
from sifflet_sdk.client.models.time_unit_column_partition_clause import (
    TimeUnitColumnPartitionClause,
)
from typing_extensions import Literal, Self

GETRULELATESTMETRICDATADTOPARTITIONCLAUSE_ONE_OF_SCHEMAS = [
    "IngestionTimePartitionClause",
    "IntegerRangePartitionClause",
    "TimeUnitColumnPartitionClause",
]


class GetRuleLatestMetricDataDtoPartitionClause(BaseModel):
    """
    GetRuleLatestMetricDataDtoPartitionClause
    """

    # data type: IngestionTimePartitionClause
    oneof_schema_1_validator: Optional[IngestionTimePartitionClause] = None
    # data type: IntegerRangePartitionClause
    oneof_schema_2_validator: Optional[IntegerRangePartitionClause] = None
    # data type: TimeUnitColumnPartitionClause
    oneof_schema_3_validator: Optional[TimeUnitColumnPartitionClause] = None
    actual_instance: Optional[
        Union[IngestionTimePartitionClause, IntegerRangePartitionClause, TimeUnitColumnPartitionClause]
    ] = None
    one_of_schemas: Set[str] = {
        "IngestionTimePartitionClause",
        "IntegerRangePartitionClause",
        "TimeUnitColumnPartitionClause",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = GetRuleLatestMetricDataDtoPartitionClause.model_construct()
        error_messages = []
        match = 0
        # validate data type: IngestionTimePartitionClause
        if not isinstance(v, IngestionTimePartitionClause):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IngestionTimePartitionClause`")
        else:
            match += 1
        # validate data type: IntegerRangePartitionClause
        if not isinstance(v, IntegerRangePartitionClause):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IntegerRangePartitionClause`")
        else:
            match += 1
        # validate data type: TimeUnitColumnPartitionClause
        if not isinstance(v, TimeUnitColumnPartitionClause):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TimeUnitColumnPartitionClause`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in GetRuleLatestMetricDataDtoPartitionClause with oneOf schemas: IngestionTimePartitionClause, IntegerRangePartitionClause, TimeUnitColumnPartitionClause. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in GetRuleLatestMetricDataDtoPartitionClause with oneOf schemas: IngestionTimePartitionClause, IntegerRangePartitionClause, TimeUnitColumnPartitionClause. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("partitioningType")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `partitioningType` in the input.")

        # check if data type is `IngestionTimePartitionClause`
        if _data_type == "INGESTION_TIME":
            instance.actual_instance = IngestionTimePartitionClause.from_json(json_str)
            return instance

        # check if data type is `IntegerRangePartitionClause`
        if _data_type == "INTEGER_RANGE":
            instance.actual_instance = IntegerRangePartitionClause.from_json(json_str)
            return instance

        # check if data type is `TimeUnitColumnPartitionClause`
        if _data_type == "TIME_UNIT_COLUMN":
            instance.actual_instance = TimeUnitColumnPartitionClause.from_json(json_str)
            return instance

        # check if data type is `IngestionTimePartitionClause`
        if _data_type == "IngestionTimePartitionClause":
            instance.actual_instance = IngestionTimePartitionClause.from_json(json_str)
            return instance

        # check if data type is `IntegerRangePartitionClause`
        if _data_type == "IntegerRangePartitionClause":
            instance.actual_instance = IntegerRangePartitionClause.from_json(json_str)
            return instance

        # check if data type is `TimeUnitColumnPartitionClause`
        if _data_type == "TimeUnitColumnPartitionClause":
            instance.actual_instance = TimeUnitColumnPartitionClause.from_json(json_str)
            return instance

        # deserialize data into IngestionTimePartitionClause
        try:
            instance.actual_instance = IngestionTimePartitionClause.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into IntegerRangePartitionClause
        try:
            instance.actual_instance = IntegerRangePartitionClause.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TimeUnitColumnPartitionClause
        try:
            instance.actual_instance = TimeUnitColumnPartitionClause.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into GetRuleLatestMetricDataDtoPartitionClause with oneOf schemas: IngestionTimePartitionClause, IntegerRangePartitionClause, TimeUnitColumnPartitionClause. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into GetRuleLatestMetricDataDtoPartitionClause with oneOf schemas: IngestionTimePartitionClause, IntegerRangePartitionClause, TimeUnitColumnPartitionClause. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[Dict[str, Any], IngestionTimePartitionClause, IntegerRangePartitionClause, TimeUnitColumnPartitionClause]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
