# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.graph_dto import GraphDto
from sifflet_sdk.client.models.histogram_graph_dto import HistogramGraphDto
from sifflet_sdk.client.models.multi_metrics_graph_dto import MultiMetricsGraphDto
from sifflet_sdk.client.models.time_series_graph_dto import TimeSeriesGraphDto
from typing_extensions import Literal, Self

GETSIFFLETRULEGRAPH200RESPONSEINNER_ONE_OF_SCHEMAS = [
    "GraphDto",
    "HistogramGraphDto",
    "MultiMetricsGraphDto",
    "TimeSeriesGraphDto",
]


class GetSiffletRuleGraph200ResponseInner(BaseModel):
    """
    GetSiffletRuleGraph200ResponseInner
    """

    # data type: GraphDto
    oneof_schema_1_validator: Optional[GraphDto] = None
    # data type: HistogramGraphDto
    oneof_schema_2_validator: Optional[HistogramGraphDto] = None
    # data type: MultiMetricsGraphDto
    oneof_schema_3_validator: Optional[MultiMetricsGraphDto] = None
    # data type: TimeSeriesGraphDto
    oneof_schema_4_validator: Optional[TimeSeriesGraphDto] = None
    actual_instance: Optional[Union[GraphDto, HistogramGraphDto, MultiMetricsGraphDto, TimeSeriesGraphDto]] = None
    one_of_schemas: Set[str] = {"GraphDto", "HistogramGraphDto", "MultiMetricsGraphDto", "TimeSeriesGraphDto"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = GetSiffletRuleGraph200ResponseInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: GraphDto
        if not isinstance(v, GraphDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GraphDto`")
        else:
            match += 1
        # validate data type: HistogramGraphDto
        if not isinstance(v, HistogramGraphDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `HistogramGraphDto`")
        else:
            match += 1
        # validate data type: MultiMetricsGraphDto
        if not isinstance(v, MultiMetricsGraphDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MultiMetricsGraphDto`")
        else:
            match += 1
        # validate data type: TimeSeriesGraphDto
        if not isinstance(v, TimeSeriesGraphDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TimeSeriesGraphDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in GetSiffletRuleGraph200ResponseInner with oneOf schemas: GraphDto, HistogramGraphDto, MultiMetricsGraphDto, TimeSeriesGraphDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in GetSiffletRuleGraph200ResponseInner with oneOf schemas: GraphDto, HistogramGraphDto, MultiMetricsGraphDto, TimeSeriesGraphDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("graphType")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `graphType` in the input.")

        # check if data type is `GraphDto`
        if _data_type == "GraphDto":
            instance.actual_instance = GraphDto.from_json(json_str)
            return instance

        # check if data type is `HistogramGraphDto`
        if _data_type == "HistogramGraphDto":
            instance.actual_instance = HistogramGraphDto.from_json(json_str)
            return instance

        # check if data type is `MultiMetricsGraphDto`
        if _data_type == "MultiMetricsGraphDto":
            instance.actual_instance = MultiMetricsGraphDto.from_json(json_str)
            return instance

        # check if data type is `TimeSeriesGraphDto`
        if _data_type == "TimeSeriesGraphDto":
            instance.actual_instance = TimeSeriesGraphDto.from_json(json_str)
            return instance

        # deserialize data into GraphDto
        try:
            instance.actual_instance = GraphDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into HistogramGraphDto
        try:
            instance.actual_instance = HistogramGraphDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MultiMetricsGraphDto
        try:
            instance.actual_instance = MultiMetricsGraphDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TimeSeriesGraphDto
        try:
            instance.actual_instance = TimeSeriesGraphDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into GetSiffletRuleGraph200ResponseInner with oneOf schemas: GraphDto, HistogramGraphDto, MultiMetricsGraphDto, TimeSeriesGraphDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into GetSiffletRuleGraph200ResponseInner with oneOf schemas: GraphDto, HistogramGraphDto, MultiMetricsGraphDto, TimeSeriesGraphDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[Union[Dict[str, Any], GraphDto, HistogramGraphDto, MultiMetricsGraphDto, TimeSeriesGraphDto]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
