# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.group_values_hash import GroupValuesHash
from typing_extensions import Self


class GroupsInfo(BaseModel):
    """
    GroupsInfo
    """  # noqa: E501

    group_by_field_names: List[StrictStr] = Field(alias="groupByFieldNames")
    group_values_hashes: List[GroupValuesHash] = Field(alias="groupValuesHashes")
    hash_secondary_salt: StrictStr = Field(alias="hashSecondarySalt")
    __properties: ClassVar[List[str]] = ["groupByFieldNames", "groupValuesHashes", "hashSecondarySalt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GroupsInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in group_values_hashes (list)
        _items = []
        if self.group_values_hashes:
            for _item_group_values_hashes in self.group_values_hashes:
                if _item_group_values_hashes:
                    _items.append(_item_group_values_hashes.to_dict())
            _dict["groupValuesHashes"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GroupsInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "groupByFieldNames": obj.get("groupByFieldNames"),
                "groupValuesHashes": (
                    [GroupValuesHash.from_dict(_item) for _item in obj["groupValuesHashes"]]
                    if obj.get("groupValuesHashes") is not None
                    else None
                ),
                "hashSecondarySalt": obj.get("hashSecondarySalt"),
            }
        )
        return _obj
