# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from sifflet_sdk.client.models.issue_brief_dto import IssueBriefDto
from typing_extensions import Self


class IncidentHeatMapCellDto(BaseModel):
    """
    IncidentHeatMapCellDto
    """  # noqa: E501

    dim_x: Optional[StrictInt] = Field(default=None, alias="dimX")
    dim_y: Optional[StrictInt] = Field(default=None, alias="dimY")
    incident_quantity: Optional[StrictInt] = Field(default=None, alias="incidentQuantity")
    issue_no: Optional[List[IssueBriefDto]] = Field(default=None, alias="issueNo")
    __properties: ClassVar[List[str]] = ["dimX", "dimY", "incidentQuantity", "issueNo"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IncidentHeatMapCellDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in issue_no (list)
        _items = []
        if self.issue_no:
            for _item_issue_no in self.issue_no:
                if _item_issue_no:
                    _items.append(_item_issue_no.to_dict())
            _dict["issueNo"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IncidentHeatMapCellDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "dimX": obj.get("dimX"),
                "dimY": obj.get("dimY"),
                "incidentQuantity": obj.get("incidentQuantity"),
                "issueNo": (
                    [IssueBriefDto.from_dict(_item) for _item in obj["issueNo"]]
                    if obj.get("issueNo") is not None
                    else None
                ),
            }
        )
        return _obj
