# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from sifflet_sdk.client.models.incident_heat_map_cell_dto import IncidentHeatMapCellDto
from typing_extensions import Self


class IncidentHeatMapDto(BaseModel):
    """
    IncidentHeatMapDto
    """  # noqa: E501

    heat_map_cells: Optional[List[IncidentHeatMapCellDto]] = Field(default=None, alias="heatMapCells")
    total_incidents: Optional[StrictInt] = Field(default=None, alias="totalIncidents")
    __properties: ClassVar[List[str]] = ["heatMapCells", "totalIncidents"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IncidentHeatMapDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in heat_map_cells (list)
        _items = []
        if self.heat_map_cells:
            for _item_heat_map_cells in self.heat_map_cells:
                if _item_heat_map_cells:
                    _items.append(_item_heat_map_cells.to_dict())
            _dict["heatMapCells"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IncidentHeatMapDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "heatMapCells": (
                    [IncidentHeatMapCellDto.from_dict(_item) for _item in obj["heatMapCells"]]
                    if obj.get("heatMapCells") is not None
                    else None
                ),
                "totalIncidents": obj.get("totalIncidents"),
            }
        )
        return _obj
