# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing_extensions import Annotated, Self


class IncidentSearchCriteria(BaseModel):
    """
    IncidentSearchCriteria
    """  # noqa: E501

    criticality: Optional[List[Annotated[int, Field(le=3, strict=True, ge=0)]]] = None
    dataset: Optional[List[StrictStr]] = None
    domain: Optional[StrictStr] = None
    var_from: Optional[StrictInt] = Field(default=None, alias="from")
    incident: Optional[List[StrictStr]] = None
    items_per_page: Optional[StrictInt] = Field(default=25, alias="itemsPerPage")
    page: Optional[StrictInt] = 0
    rule: Optional[List[StrictStr]] = None
    sort: Optional[List[StrictStr]] = None
    status: Optional[List[StrictStr]] = None
    tag: Optional[List[StrictStr]] = None
    text_search: Optional[StrictStr] = Field(default=None, alias="textSearch")
    to: Optional[StrictInt] = None
    user: Optional[List[StrictStr]] = None
    __properties: ClassVar[List[str]] = [
        "criticality",
        "dataset",
        "domain",
        "from",
        "incident",
        "itemsPerPage",
        "page",
        "rule",
        "sort",
        "status",
        "tag",
        "textSearch",
        "to",
        "user",
    ]

    @field_validator("status")
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(["OPEN", "IN_PROGRESS", "CLOSED"]):
                raise ValueError("each list item must be one of ('OPEN', 'IN_PROGRESS', 'CLOSED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IncidentSearchCriteria from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IncidentSearchCriteria from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "criticality": obj.get("criticality"),
                "dataset": obj.get("dataset"),
                "domain": obj.get("domain"),
                "from": obj.get("from"),
                "incident": obj.get("incident"),
                "itemsPerPage": obj.get("itemsPerPage") if obj.get("itemsPerPage") is not None else 25,
                "page": obj.get("page") if obj.get("page") is not None else 0,
                "rule": obj.get("rule"),
                "sort": obj.get("sort"),
                "status": obj.get("status"),
                "tag": obj.get("tag"),
                "textSearch": obj.get("textSearch"),
                "to": obj.get("to"),
                "user": obj.get("user"),
            }
        )
        return _obj
