# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from sifflet_sdk.client.models.incident_group_summary_dto import IncidentGroupSummaryDto
from typing_extensions import Self


class IncidentSummaryDto(BaseModel):
    """
    IncidentSummaryDto
    """  # noqa: E501

    average_response_rate: Optional[StrictInt] = Field(default=None, alias="averageResponseRate")
    rate_comparison_last_week: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, alias="rateComparisonLastWeek"
    )
    total_elements: Optional[StrictInt] = Field(default=None, alias="totalElements")
    unresolved_incidents_by_status: Optional[Dict[str, IncidentGroupSummaryDto]] = Field(
        default=None, alias="unresolvedIncidentsByStatus"
    )
    __properties: ClassVar[List[str]] = [
        "averageResponseRate",
        "rateComparisonLastWeek",
        "totalElements",
        "unresolvedIncidentsByStatus",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IncidentSummaryDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in unresolved_incidents_by_status (dict)
        _field_dict = {}
        if self.unresolved_incidents_by_status:
            for _key_unresolved_incidents_by_status in self.unresolved_incidents_by_status:
                if self.unresolved_incidents_by_status[_key_unresolved_incidents_by_status]:
                    _field_dict[_key_unresolved_incidents_by_status] = self.unresolved_incidents_by_status[
                        _key_unresolved_incidents_by_status
                    ].to_dict()
            _dict["unresolvedIncidentsByStatus"] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IncidentSummaryDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "averageResponseRate": obj.get("averageResponseRate"),
                "rateComparisonLastWeek": obj.get("rateComparisonLastWeek"),
                "totalElements": obj.get("totalElements"),
                "unresolvedIncidentsByStatus": (
                    dict(
                        (_k, IncidentGroupSummaryDto.from_dict(_v))
                        for _k, _v in obj["unresolvedIncidentsByStatus"].items()
                    )
                    if obj.get("unresolvedIncidentsByStatus") is not None
                    else None
                ),
            }
        )
        return _obj
