# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.execute_prepared_statement_job_action import (
    ExecutePreparedStatementJobAction,
)
from sifflet_sdk.client.models.execute_statement_job_action import (
    ExecuteStatementJobAction,
)
from sifflet_sdk.client.models.get_schemas_in_database_job_action import (
    GetSchemasInDatabaseJobAction,
)
from sifflet_sdk.client.models.get_tables_job_action import GetTablesJobAction
from typing_extensions import Literal, Self

JDBCDATASOURCEJOBPARAMSALLOFACTION_ONE_OF_SCHEMAS = [
    "ExecutePreparedStatementJobAction",
    "ExecuteStatementJobAction",
    "GetSchemasInDatabaseJobAction",
    "GetTablesJobAction",
]


class JdbcDatasourceJobParamsAllOfAction(BaseModel):
    """
    JdbcDatasourceJobParamsAllOfAction
    """

    # data type: ExecutePreparedStatementJobAction
    oneof_schema_1_validator: Optional[ExecutePreparedStatementJobAction] = None
    # data type: ExecuteStatementJobAction
    oneof_schema_2_validator: Optional[ExecuteStatementJobAction] = None
    # data type: GetSchemasInDatabaseJobAction
    oneof_schema_3_validator: Optional[GetSchemasInDatabaseJobAction] = None
    # data type: GetTablesJobAction
    oneof_schema_4_validator: Optional[GetTablesJobAction] = None
    actual_instance: Optional[
        Union[
            ExecutePreparedStatementJobAction,
            ExecuteStatementJobAction,
            GetSchemasInDatabaseJobAction,
            GetTablesJobAction,
        ]
    ] = None
    one_of_schemas: Set[str] = {
        "ExecutePreparedStatementJobAction",
        "ExecuteStatementJobAction",
        "GetSchemasInDatabaseJobAction",
        "GetTablesJobAction",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = JdbcDatasourceJobParamsAllOfAction.model_construct()
        error_messages = []
        match = 0
        # validate data type: ExecutePreparedStatementJobAction
        if not isinstance(v, ExecutePreparedStatementJobAction):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ExecutePreparedStatementJobAction`")
        else:
            match += 1
        # validate data type: ExecuteStatementJobAction
        if not isinstance(v, ExecuteStatementJobAction):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ExecuteStatementJobAction`")
        else:
            match += 1
        # validate data type: GetSchemasInDatabaseJobAction
        if not isinstance(v, GetSchemasInDatabaseJobAction):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GetSchemasInDatabaseJobAction`")
        else:
            match += 1
        # validate data type: GetTablesJobAction
        if not isinstance(v, GetTablesJobAction):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GetTablesJobAction`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in JdbcDatasourceJobParamsAllOfAction with oneOf schemas: ExecutePreparedStatementJobAction, ExecuteStatementJobAction, GetSchemasInDatabaseJobAction, GetTablesJobAction. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in JdbcDatasourceJobParamsAllOfAction with oneOf schemas: ExecutePreparedStatementJobAction, ExecuteStatementJobAction, GetSchemasInDatabaseJobAction, GetTablesJobAction. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `ExecutePreparedStatementJobAction`
        if _data_type == "EXECUTE_PREPARED_STATEMENT":
            instance.actual_instance = ExecutePreparedStatementJobAction.from_json(json_str)
            return instance

        # check if data type is `ExecuteStatementJobAction`
        if _data_type == "EXECUTE_STATEMENT":
            instance.actual_instance = ExecuteStatementJobAction.from_json(json_str)
            return instance

        # check if data type is `GetSchemasInDatabaseJobAction`
        if _data_type == "GET_SCHEMAS_IN_DATABASE":
            instance.actual_instance = GetSchemasInDatabaseJobAction.from_json(json_str)
            return instance

        # check if data type is `GetTablesJobAction`
        if _data_type == "GET_TABLES":
            instance.actual_instance = GetTablesJobAction.from_json(json_str)
            return instance

        # check if data type is `ExecutePreparedStatementJobAction`
        if _data_type == "ExecutePreparedStatementJobAction":
            instance.actual_instance = ExecutePreparedStatementJobAction.from_json(json_str)
            return instance

        # check if data type is `ExecuteStatementJobAction`
        if _data_type == "ExecuteStatementJobAction":
            instance.actual_instance = ExecuteStatementJobAction.from_json(json_str)
            return instance

        # check if data type is `GetSchemasInDatabaseJobAction`
        if _data_type == "GetSchemasInDatabaseJobAction":
            instance.actual_instance = GetSchemasInDatabaseJobAction.from_json(json_str)
            return instance

        # check if data type is `GetTablesJobAction`
        if _data_type == "GetTablesJobAction":
            instance.actual_instance = GetTablesJobAction.from_json(json_str)
            return instance

        # deserialize data into ExecutePreparedStatementJobAction
        try:
            instance.actual_instance = ExecutePreparedStatementJobAction.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ExecuteStatementJobAction
        try:
            instance.actual_instance = ExecuteStatementJobAction.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into GetSchemasInDatabaseJobAction
        try:
            instance.actual_instance = GetSchemasInDatabaseJobAction.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into GetTablesJobAction
        try:
            instance.actual_instance = GetTablesJobAction.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into JdbcDatasourceJobParamsAllOfAction with oneOf schemas: ExecutePreparedStatementJobAction, ExecuteStatementJobAction, GetSchemasInDatabaseJobAction, GetTablesJobAction. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into JdbcDatasourceJobParamsAllOfAction with oneOf schemas: ExecutePreparedStatementJobAction, ExecuteStatementJobAction, GetSchemasInDatabaseJobAction, GetTablesJobAction. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[
            Dict[str, Any],
            ExecutePreparedStatementJobAction,
            ExecuteStatementJobAction,
            GetSchemasInDatabaseJobAction,
            GetTablesJobAction,
        ]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
