# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from sifflet_sdk.client.models.agent_job_result_dto_data import AgentJobResultDtoData
from typing_extensions import Self


class JobResultDto(BaseModel):
    """
    JobResultDto
    """  # noqa: E501

    data: Optional[AgentJobResultDtoData] = None
    job_id: StrictStr = Field(alias="jobId")
    job_status: StrictStr = Field(alias="jobStatus")
    __properties: ClassVar[List[str]] = ["data", "jobId", "jobStatus"]

    @field_validator("job_status")
    def job_status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["PENDING", "IN_PROGRESS", "SUCCESS", "FAILURE", "CANCELLED", "TIMED_OUT"]):
            raise ValueError(
                "must be one of enum values ('PENDING', 'IN_PROGRESS', 'SUCCESS', 'FAILURE', 'CANCELLED', 'TIMED_OUT')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JobResultDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data
        if self.data:
            _dict["data"] = self.data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JobResultDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "data": AgentJobResultDtoData.from_dict(obj["data"]) if obj.get("data") is not None else None,
                "jobId": obj.get("jobId"),
                "jobStatus": obj.get("jobStatus"),
            }
        )
        return _obj
