# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictBool,
    StrictStr,
    field_validator,
)
from sifflet_sdk.client.models.rule_status_dto import RuleStatusDto
from typing_extensions import Self


class LightSchemaFieldDto(BaseModel):
    """
    LightSchemaFieldDto
    """  # noqa: E501

    monitored: Optional[StrictBool] = None
    name: StrictStr
    rule_statuses: List[RuleStatusDto] = Field(alias="ruleStatuses")
    type: StrictStr
    type_category: Optional[StrictStr] = Field(default=None, alias="typeCategory")
    __properties: ClassVar[List[str]] = ["monitored", "name", "ruleStatuses", "type", "typeCategory"]

    @field_validator("type_category")
    def type_category_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "DATE",
                "TIME",
                "DATETIME",
                "BOOLEAN",
                "STRING",
                "INTEGER",
                "FLOAT",
                "ARRAY",
                "JSON",
                "STRUCT",
                "MAP",
                "BINARY",
                "OTHER",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('DATE', 'TIME', 'DATETIME', 'BOOLEAN', 'STRING', 'INTEGER', 'FLOAT', 'ARRAY', 'JSON', 'STRUCT', 'MAP', 'BINARY', 'OTHER')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LightSchemaFieldDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rule_statuses (list)
        _items = []
        if self.rule_statuses:
            for _item_rule_statuses in self.rule_statuses:
                if _item_rule_statuses:
                    _items.append(_item_rule_statuses.to_dict())
            _dict["ruleStatuses"] = _items
        # set to None if type_category (nullable) is None
        # and model_fields_set contains the field
        if self.type_category is None and "type_category" in self.model_fields_set:
            _dict["typeCategory"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LightSchemaFieldDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "monitored": obj.get("monitored"),
                "name": obj.get("name"),
                "ruleStatuses": (
                    [RuleStatusDto.from_dict(_item) for _item in obj["ruleStatuses"]]
                    if obj.get("ruleStatuses") is not None
                    else None
                ),
                "type": obj.get("type"),
                "typeCategory": obj.get("typeCategory"),
            }
        )
        return _obj
