# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictBool,
    StrictStr,
    field_validator,
)
from sifflet_sdk.client.models.generating_transformation_status_dto import (
    GeneratingTransformationStatusDto,
)
from sifflet_sdk.client.models.lineage_attached_entity import LineageAttachedEntity
from sifflet_sdk.client.models.lineage_urn_dto import LineageUrnDto
from typing_extensions import Self


class LineageEntityDto(BaseModel):
    """
    LineageEntityDto
    """  # noqa: E501

    access_authorized: Optional[StrictBool] = Field(default=None, alias="accessAuthorized")
    attached_entity: Optional[LineageAttachedEntity] = Field(default=None, alias="attachedEntity")
    children: List[LineageEntityDto]
    datasource_name: Optional[StrictStr] = Field(default=None, alias="datasourceName")
    downstreams: List[LineageUrnDto]
    entity_type: StrictStr = Field(alias="entityType")
    generating_transformation_status: Optional[GeneratingTransformationStatusDto] = Field(
        default=None, alias="generatingTransformationStatus"
    )
    has_information: StrictBool = Field(alias="hasInformation")
    health: StrictStr
    id: StrictStr
    platform: StrictStr
    platform_enum: StrictStr = Field(alias="platformEnum")
    qualified_name_prefix: Optional[StrictStr] = Field(default=None, alias="qualifiedNamePrefix")
    title: StrictStr
    type: StrictStr
    upstreams: List[LineageUrnDto]
    urn: StrictStr
    __properties: ClassVar[List[str]] = [
        "accessAuthorized",
        "attachedEntity",
        "children",
        "datasourceName",
        "downstreams",
        "entityType",
        "generatingTransformationStatus",
        "hasInformation",
        "health",
        "id",
        "platform",
        "platformEnum",
        "qualifiedNamePrefix",
        "title",
        "type",
        "upstreams",
        "urn",
    ]

    @field_validator("entity_type")
    def entity_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(
            [
                "INTEGRATION",
                "DATASOURCE",
                "DATASOURCE_INGESTION_RUN",
                "DATASET",
                "DASHBOARD",
                "CHART",
                "COLLECTION",
                "DATASET_FIELD",
                "DAG",
                "TRANSFORMATION",
                "RULE_RUN",
                "INCIDENT",
                "USER",
                "ACCESS_TOKEN",
                "SIFFLET_RULE",
                "CONFIG",
                "TAG",
                "DOMAIN",
                "ALERTING_HOOK",
                "RULE_MONITORING_RECOMMENDATION",
                "DATAPOINT_QUALIFICATION",
                "DECLARED_ASSET",
                "WEBHOOK",
                "SIFFLET_AGENT",
                "SIFFLET_AGENT_JOB",
                "AI_METADATA_PREDICTION",
                "CUSTOM_METADATA",
                "CUSTOM_METADATA_ENTRY",
                "DATA_PRODUCT",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('INTEGRATION', 'DATASOURCE', 'DATASOURCE_INGESTION_RUN', 'DATASET', 'DASHBOARD', 'CHART', 'COLLECTION', 'DATASET_FIELD', 'DAG', 'TRANSFORMATION', 'RULE_RUN', 'INCIDENT', 'USER', 'ACCESS_TOKEN', 'SIFFLET_RULE', 'CONFIG', 'TAG', 'DOMAIN', 'ALERTING_HOOK', 'RULE_MONITORING_RECOMMENDATION', 'DATAPOINT_QUALIFICATION', 'DECLARED_ASSET', 'WEBHOOK', 'SIFFLET_AGENT', 'SIFFLET_AGENT_JOB', 'AI_METADATA_PREDICTION', 'CUSTOM_METADATA', 'CUSTOM_METADATA_ENTRY', 'DATA_PRODUCT')"
            )
        return value

    @field_validator("health")
    def health_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["CRITICAL", "AT_RISK", "HEALTHY", "UNMONITORED", "NOT_SUPPORTED"]):
            raise ValueError(
                "must be one of enum values ('CRITICAL', 'AT_RISK', 'HEALTHY', 'UNMONITORED', 'NOT_SUPPORTED')"
            )
        return value

    @field_validator("platform_enum")
    def platform_enum_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(
            [
                "ATHENA",
                "BIGQUERY",
                "FIREBOLT",
                "PRESTO",
                "REDSHIFT",
                "SNOWFLAKE",
                "DATABRICKS",
                "MSSQL",
                "MYSQL",
                "SYNAPSE",
                "POSTGRES",
                "H2",
                "ORACLE",
                "LIGHTDASH",
                "LOOKER",
                "METABASE",
                "MICROSTRATEGY",
                "TABLEAU",
                "POWER_BI",
                "QLIK",
                "QUICKSIGHT",
                "STITCH",
                "AIRBYTE",
                "AIRFLOW",
                "COMPOSER",
                "DAGSTER",
                "DBT",
                "DBTCLOUD",
                "FIVETRAN",
                "MWAA",
                "PREFECT",
                "TALEND",
                "HUBSPOT",
                "INFORMATICA",
                "MULESOFT",
                "SALESFORCE",
                "SEGMENT",
                "SLACK",
                "CENSUS",
                "HIGH_TOUCH",
                "AMAZON_SAGEMAKER",
                "DATAIKU",
                "MICROSOFT_AZURE_ML",
                "GOOGLE_ANALYTICS",
                "SIGMA",
                "UNKNOWN",
                "AZURE",
                "GOOGLE_DRIVE",
                "GOOGLE_SHEETS",
                "GOOGLE_CLOUD_STORAGE",
                "S3",
                "EXCEL",
                "GITHUB",
                "SIXSENSE",
                "FIFTEENFIVE",
                "THREESIXTYLEARNING",
                "ACCELDATA",
                "ACRYL_DATA",
                "ACTIAN_VECTOR",
                "ACTIVE_CAMPAIGN",
                "ADA",
                "ADJUST",
                "ADOBE",
                "ADP_WFN",
                "ADROLL",
                "AFFINITY",
                "AIRCALL",
                "AIRTABLE",
                "ALATION",
                "ALCHEMER",
                "ALVIN_AI",
                "AMAZON",
                "AMAZON_CLOUDFRONT",
                "AMAZON_DOCUMENTDB",
                "AMAZON_DYNAMODB",
                "AMAZON_FIREHOSE",
                "AMAZON_SELLING_PARTNER",
                "AMPLITUDE",
                "ANAPLAN",
                "ANOMALO",
                "APACHE_KAFKA",
                "APACHE_SPARK",
                "APPCUES",
                "APPFIGURES",
                "APPLE",
                "APPLE_APP_STORE",
                "APPSFLYER",
                "ASANA",
                "ASSEMBLED",
                "ATLAN",
                "ATLASSIAN_CONFLUENCE",
                "ATLASSIAN_JIRA",
                "ATLASSIAN_OPSGENIE",
                "AUTH0",
                "AUTODESK_BIM_360",
                "AWIN",
                "AWS_CLOUDTRAIL",
                "AWS_COST_EXPLORER",
                "AWS_INVENTORY",
                "AWS_LAMBDA",
                "BALLOT_READY",
                "BAMBOOHR",
                "BIGCOMMERCE",
                "BIGEYE",
                "BILLINGPLATFORM",
                "BIRDEYE",
                "BLACKBOARD",
                "BOX",
                "BRAINTREE",
                "BRAZE",
                "BREX",
                "BUILDKITE",
                "BUZZSPROUT",
                "CALENDLY",
                "CAMPAIGN_MONITOR",
                "CANNY",
                "CANVAS",
                "CAPTERRA",
                "CASTOR_DOC",
                "CERTINIA",
                "CHAMELEON",
                "CHANNEL_ADVISOR",
                "CHARGEBEE",
                "CHARGEDESK",
                "CHARTMOGUL",
                "CHORUS_AI",
                "CHURNKEY",
                "CHURNZERO",
                "CIMIS",
                "CIN7",
                "CIRCLE_CI",
                "CLARI",
                "CLICKUP",
                "CLIFF_AI",
                "CLOSE",
                "COLLIBRA",
                "COMMERCETOOLS",
                "CONFLUENT_CLOUD",
                "CONTRAST_SECURITY",
                "COUPA",
                "CRITEO",
                "CROSSBEAM",
                "CRUNCHBASE",
                "CUSTOMER_IO",
                "D2L_BRIGHTSPACE",
                "DATA_WORLD",
                "DATABAND",
                "DATADOG",
                "DATAEDO",
                "DATAFOLD",
                "DATAGALAXY",
                "DATAHUB",
                "DB2",
                "DCL_LOGISTICS",
                "DEAR",
                "DECUBE",
                "DELIGHTED",
                "DEPUTY",
                "DESTINI",
                "DIXA",
                "DOCEBO",
                "DRATA",
                "DRIFT",
                "DRIP",
                "DROPBOX",
                "DUOPLANE",
                "E_CONOMIC",
                "EASY_POST",
                "ELASTICSEARCH",
                "ELEMENTARY",
                "ELLUCIAN",
                "ELOQUA",
                "EMAIL",
                "EMPLOYMENT_HERO",
                "EPICOR_PROPHET_21",
                "EVENTBRITE",
                "EVERHOUR",
                "EXPENSIFY",
                "FACEBOOK",
                "FIGMA",
                "FIREBASE",
                "FLEXPORT",
                "FORJ",
                "FOUNTAIN",
                "FREIGHTVIEW",
                "FRESHBOOKS",
                "FRESHCHAT",
                "FRESHDESK",
                "FRESHDESK_CONTACT_CENTER",
                "FRESHSERVICE",
                "FRESHSUCCESS",
                "FRESHTEAM",
                "FRIENDBUY",
                "FRONT",
                "FTP",
                "FULLSTORY",
                "G2",
                "GAINSIGHT",
                "GEM",
                "GIT",
                "GITLAB",
                "GLADLY",
                "GOCARDLESS",
                "GONG",
                "GOOGLE",
                "GOOGLE_AD_MANAGER",
                "GOOGLE_ADS",
                "GOOGLE_CALENDAR",
                "GOOGLE_CAMPAIGN_MANAGER",
                "GOOGLE_CHROME",
                "GOOGLE_CLOUD",
                "GOOGLE_DISPLAY",
                "GOOGLE_PLAY",
                "GOOGLE_SEARCH_ADS_360",
                "GOOGLE_SEARCH_CONSOLE",
                "GOOGLE_TASKS",
                "GORGIAS",
                "GREENHOUSE",
                "GREENPLUM",
                "GREEN_POWER_MONITOR",
                "GREPSR",
                "GRIN",
                "GURU",
                "HARVEST",
                "HDFS",
                "HEAP",
                "HEIGHT",
                "HELP_SCOUT",
                "HELPSHIFT",
                "HEROKU_KAFKA",
                "HEX",
                "HIBOB",
                "HOPIN",
                "IMPACT",
                "INCIDENT_IO",
                "INFOBIP",
                "INSIGHTLY",
                "INSTAGRAM",
                "INTERCOM",
                "INVESTOPEDIA",
                "IRONCLAD",
                "IRONSOURCE",
                "ITERABLE",
                "JAVA",
                "JENKINS",
                "JUSTCALL",
                "KANDJI",
                "KENSU",
                "KHOROS_CARE",
                "KISSMETRICS",
                "KLAVIYO",
                "KNOWBE4",
                "KONNECT_INSIGHTS",
                "KUSTOMER",
                "LARIAT_DATA",
                "LATTICE",
                "LAUNCH_DARKLY",
                "LEARN_UPON",
                "LESSONLY",
                "LEVER",
                "LIFTOFF",
                "LIGHTSPEED",
                "LIGHTSUP",
                "LINEAR",
                "LINKEDIN",
                "LIVECHAT",
                "LOADED_COMMERCE",
                "LOB",
                "LOOP",
                "LOOPIO",
                "LUMA",
                "MAGENTO",
                "MAILCHIMP",
                "MAILGUN",
                "MANDRILL",
                "MANTA",
                "MARIADB",
                "MARIN_SOFTWARE",
                "MARKETO",
                "MATTERMOST",
                "MAVENLINK",
                "MAXIO",
                "MEDALLIA",
                "META",
                "METAPHOR",
                "METAPLANE",
                "MICROSOFT",
                "MICROSOFT_AZURE_BLOB_STORAGE",
                "MICROSOFT_DYNAMICS",
                "MICROSOFT_ONEDRIVE",
                "MICROSOFT_PURVIEW",
                "MICROSOFT_TEAMS",
                "MIXMAX",
                "MIXPANEL",
                "MONDAY_COM",
                "MONGODB",
                "MONTE_CARLO",
                "MOUNTAIN",
                "MUX",
                "NAMELY",
                "NCINO",
                "NETSUITE_ANALYTICS",
                "NEW_RELIC",
                "NOTION",
                "NYLAS",
                "OBSERVE",
                "OCTOPAI",
                "OKTA",
                "OPEN_DATA_DC",
                "OPEN_EXCHANGES_RATES",
                "OPEN_AI",
                "OPEN_SEARCH",
                "OPTIMIZELY",
                "ORBIT_COMMUNITY_PLATFORM",
                "ORDWAY",
                "ORTTO",
                "OS_COMMERCE",
                "OUTBRAIN",
                "OUTREACH",
                "OVALEDGE",
                "PAGERDUTY",
                "PAGERSHIFT",
                "PAYPAL",
                "PENDO",
                "PINGDOM",
                "PINTEREST",
                "PIPE17",
                "PIPEDRIVE",
                "PIVOTAL_TRACKER",
                "PLAYVOX",
                "POSTHOG",
                "POWERSCHOOL",
                "PRESTASHOP",
                "PRODUCTBOARD",
                "PYTHON",
                "QUALAROO",
                "QUALTRICS",
                "QUICKBOOKS",
                "RAMP",
                "RARIBLE",
                "RECHARGE",
                "RECURLY",
                "REDDIT",
                "RELTIO",
                "REPLY_IO",
                "RETAILNEXT",
                "RETENTLY",
                "REVEL_SYSTEMS",
                "RINGCENTRAL",
                "RIPPLING",
                "ROLLBAR",
                "ROOTLY",
                "SAGE_HR",
                "SAGE_INTACCT",
                "SAILTHRU",
                "SALESLOFT",
                "SALSIFY",
                "SAMSARA",
                "SAP",
                "SAP_CONCUR",
                "SCORM",
                "SECODA",
                "SECURITY_JOURNEY",
                "SELECT_STAR",
                "SENDGRID",
                "BREVO",
                "SERVICE_NOW",
                "SFTP",
                "SHAREPOINT",
                "SHARETRIBE",
                "SHIPHERO",
                "SHIPSTATION",
                "SHOPIFY",
                "SHOPWARE",
                "SHORT_IO",
                "SIFFLET",
                "SIMPLECAST",
                "SIMPLESAT",
                "SINGLESTORE",
                "SISENSE",
                "SKILLJAR",
                "SKUVAULT",
                "SLAB",
                "SMADEX",
                "SNAPCHAT",
                "SNOWPLOW",
                "SODA",
                "SONARQUBE",
                "SPLIT_IO",
                "SPLUNK",
                "SPOTIFY",
                "SPREE_COMMERCE",
                "SPROUT_SOCIAL",
                "SQUARE",
                "SQUARESPACE",
                "STACK_ADAPT",
                "STATSIG",
                "STRIPE",
                "STYLIGHT",
                "SUBSCRIPT",
                "TABOOLA",
                "TALKDESK",
                "TALKWALKER",
                "TEAMWORK_COM",
                "TEMPO_IO",
                "TERADATA",
                "TERRAFORM",
                "THE_TRADE_DESK",
                "THOUGHT_SPOT",
                "TIKTOK",
                "TOGGL",
                "TRANSCEND",
                "TRELLO",
                "TRISOLUTE",
                "TWILIO",
                "TYPEFORM",
                "UPLAND",
                "USERVOICE",
                "VALIDIO",
                "VEEVA",
                "VERIZON_MEDIA",
                "VITALLY",
                "VONAGE",
                "VUETIFY",
                "WEB_SCRAPER",
                "WEBHOOKS",
                "WHEN_I_WORK",
                "WHEREFOUR",
                "WIKIPEDIA",
                "WOOCOMMERCE",
                "WORDPRESS",
                "WORKABLE",
                "WORKDAY",
                "WORKFLOW_MAX",
                "WRIKE",
                "X",
                "XERO",
                "XRAY",
                "YAHOO",
                "YOTPO",
                "YOUTUBE",
                "ZEENEA",
                "ZEN_CART",
                "ZENDESK_CHAT",
                "ZENDESK_SELL",
                "ZENDESK_SUNSHINE",
                "ZENDESK_SUPPORT",
                "TRINET",
                "ZINGTREE",
                "ZOHO_BOOKS",
                "ZOHO_CAMPAIGNS",
                "ZOHO_CRM",
                "ZOOM",
                "ZUORA",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('ATHENA', 'BIGQUERY', 'FIREBOLT', 'PRESTO', 'REDSHIFT', 'SNOWFLAKE', 'DATABRICKS', 'MSSQL', 'MYSQL', 'SYNAPSE', 'POSTGRES', 'H2', 'ORACLE', 'LIGHTDASH', 'LOOKER', 'METABASE', 'MICROSTRATEGY', 'TABLEAU', 'POWER_BI', 'QLIK', 'QUICKSIGHT', 'STITCH', 'AIRBYTE', 'AIRFLOW', 'COMPOSER', 'DAGSTER', 'DBT', 'DBTCLOUD', 'FIVETRAN', 'MWAA', 'PREFECT', 'TALEND', 'HUBSPOT', 'INFORMATICA', 'MULESOFT', 'SALESFORCE', 'SEGMENT', 'SLACK', 'CENSUS', 'HIGH_TOUCH', 'AMAZON_SAGEMAKER', 'DATAIKU', 'MICROSOFT_AZURE_ML', 'GOOGLE_ANALYTICS', 'SIGMA', 'UNKNOWN', 'AZURE', 'GOOGLE_DRIVE', 'GOOGLE_SHEETS', 'GOOGLE_CLOUD_STORAGE', 'S3', 'EXCEL', 'GITHUB', 'SIXSENSE', 'FIFTEENFIVE', 'THREESIXTYLEARNING', 'ACCELDATA', 'ACRYL_DATA', 'ACTIAN_VECTOR', 'ACTIVE_CAMPAIGN', 'ADA', 'ADJUST', 'ADOBE', 'ADP_WFN', 'ADROLL', 'AFFINITY', 'AIRCALL', 'AIRTABLE', 'ALATION', 'ALCHEMER', 'ALVIN_AI', 'AMAZON', 'AMAZON_CLOUDFRONT', 'AMAZON_DOCUMENTDB', 'AMAZON_DYNAMODB', 'AMAZON_FIREHOSE', 'AMAZON_SELLING_PARTNER', 'AMPLITUDE', 'ANAPLAN', 'ANOMALO', 'APACHE_KAFKA', 'APACHE_SPARK', 'APPCUES', 'APPFIGURES', 'APPLE', 'APPLE_APP_STORE', 'APPSFLYER', 'ASANA', 'ASSEMBLED', 'ATLAN', 'ATLASSIAN_CONFLUENCE', 'ATLASSIAN_JIRA', 'ATLASSIAN_OPSGENIE', 'AUTH0', 'AUTODESK_BIM_360', 'AWIN', 'AWS_CLOUDTRAIL', 'AWS_COST_EXPLORER', 'AWS_INVENTORY', 'AWS_LAMBDA', 'BALLOT_READY', 'BAMBOOHR', 'BIGCOMMERCE', 'BIGEYE', 'BILLINGPLATFORM', 'BIRDEYE', 'BLACKBOARD', 'BOX', 'BRAINTREE', 'BRAZE', 'BREX', 'BUILDKITE', 'BUZZSPROUT', 'CALENDLY', 'CAMPAIGN_MONITOR', 'CANNY', 'CANVAS', 'CAPTERRA', 'CASTOR_DOC', 'CERTINIA', 'CHAMELEON', 'CHANNEL_ADVISOR', 'CHARGEBEE', 'CHARGEDESK', 'CHARTMOGUL', 'CHORUS_AI', 'CHURNKEY', 'CHURNZERO', 'CIMIS', 'CIN7', 'CIRCLE_CI', 'CLARI', 'CLICKUP', 'CLIFF_AI', 'CLOSE', 'COLLIBRA', 'COMMERCETOOLS', 'CONFLUENT_CLOUD', 'CONTRAST_SECURITY', 'COUPA', 'CRITEO', 'CROSSBEAM', 'CRUNCHBASE', 'CUSTOMER_IO', 'D2L_BRIGHTSPACE', 'DATA_WORLD', 'DATABAND', 'DATADOG', 'DATAEDO', 'DATAFOLD', 'DATAGALAXY', 'DATAHUB', 'DB2', 'DCL_LOGISTICS', 'DEAR', 'DECUBE', 'DELIGHTED', 'DEPUTY', 'DESTINI', 'DIXA', 'DOCEBO', 'DRATA', 'DRIFT', 'DRIP', 'DROPBOX', 'DUOPLANE', 'E_CONOMIC', 'EASY_POST', 'ELASTICSEARCH', 'ELEMENTARY', 'ELLUCIAN', 'ELOQUA', 'EMAIL', 'EMPLOYMENT_HERO', 'EPICOR_PROPHET_21', 'EVENTBRITE', 'EVERHOUR', 'EXPENSIFY', 'FACEBOOK', 'FIGMA', 'FIREBASE', 'FLEXPORT', 'FORJ', 'FOUNTAIN', 'FREIGHTVIEW', 'FRESHBOOKS', 'FRESHCHAT', 'FRESHDESK', 'FRESHDESK_CONTACT_CENTER', 'FRESHSERVICE', 'FRESHSUCCESS', 'FRESHTEAM', 'FRIENDBUY', 'FRONT', 'FTP', 'FULLSTORY', 'G2', 'GAINSIGHT', 'GEM', 'GIT', 'GITLAB', 'GLADLY', 'GOCARDLESS', 'GONG', 'GOOGLE', 'GOOGLE_AD_MANAGER', 'GOOGLE_ADS', 'GOOGLE_CALENDAR', 'GOOGLE_CAMPAIGN_MANAGER', 'GOOGLE_CHROME', 'GOOGLE_CLOUD', 'GOOGLE_DISPLAY', 'GOOGLE_PLAY', 'GOOGLE_SEARCH_ADS_360', 'GOOGLE_SEARCH_CONSOLE', 'GOOGLE_TASKS', 'GORGIAS', 'GREENHOUSE', 'GREENPLUM', 'GREEN_POWER_MONITOR', 'GREPSR', 'GRIN', 'GURU', 'HARVEST', 'HDFS', 'HEAP', 'HEIGHT', 'HELP_SCOUT', 'HELPSHIFT', 'HEROKU_KAFKA', 'HEX', 'HIBOB', 'HOPIN', 'IMPACT', 'INCIDENT_IO', 'INFOBIP', 'INSIGHTLY', 'INSTAGRAM', 'INTERCOM', 'INVESTOPEDIA', 'IRONCLAD', 'IRONSOURCE', 'ITERABLE', 'JAVA', 'JENKINS', 'JUSTCALL', 'KANDJI', 'KENSU', 'KHOROS_CARE', 'KISSMETRICS', 'KLAVIYO', 'KNOWBE4', 'KONNECT_INSIGHTS', 'KUSTOMER', 'LARIAT_DATA', 'LATTICE', 'LAUNCH_DARKLY', 'LEARN_UPON', 'LESSONLY', 'LEVER', 'LIFTOFF', 'LIGHTSPEED', 'LIGHTSUP', 'LINEAR', 'LINKEDIN', 'LIVECHAT', 'LOADED_COMMERCE', 'LOB', 'LOOP', 'LOOPIO', 'LUMA', 'MAGENTO', 'MAILCHIMP', 'MAILGUN', 'MANDRILL', 'MANTA', 'MARIADB', 'MARIN_SOFTWARE', 'MARKETO', 'MATTERMOST', 'MAVENLINK', 'MAXIO', 'MEDALLIA', 'META', 'METAPHOR', 'METAPLANE', 'MICROSOFT', 'MICROSOFT_AZURE_BLOB_STORAGE', 'MICROSOFT_DYNAMICS', 'MICROSOFT_ONEDRIVE', 'MICROSOFT_PURVIEW', 'MICROSOFT_TEAMS', 'MIXMAX', 'MIXPANEL', 'MONDAY_COM', 'MONGODB', 'MONTE_CARLO', 'MOUNTAIN', 'MUX', 'NAMELY', 'NCINO', 'NETSUITE_ANALYTICS', 'NEW_RELIC', 'NOTION', 'NYLAS', 'OBSERVE', 'OCTOPAI', 'OKTA', 'OPEN_DATA_DC', 'OPEN_EXCHANGES_RATES', 'OPEN_AI', 'OPEN_SEARCH', 'OPTIMIZELY', 'ORBIT_COMMUNITY_PLATFORM', 'ORDWAY', 'ORTTO', 'OS_COMMERCE', 'OUTBRAIN', 'OUTREACH', 'OVALEDGE', 'PAGERDUTY', 'PAGERSHIFT', 'PAYPAL', 'PENDO', 'PINGDOM', 'PINTEREST', 'PIPE17', 'PIPEDRIVE', 'PIVOTAL_TRACKER', 'PLAYVOX', 'POSTHOG', 'POWERSCHOOL', 'PRESTASHOP', 'PRODUCTBOARD', 'PYTHON', 'QUALAROO', 'QUALTRICS', 'QUICKBOOKS', 'RAMP', 'RARIBLE', 'RECHARGE', 'RECURLY', 'REDDIT', 'RELTIO', 'REPLY_IO', 'RETAILNEXT', 'RETENTLY', 'REVEL_SYSTEMS', 'RINGCENTRAL', 'RIPPLING', 'ROLLBAR', 'ROOTLY', 'SAGE_HR', 'SAGE_INTACCT', 'SAILTHRU', 'SALESLOFT', 'SALSIFY', 'SAMSARA', 'SAP', 'SAP_CONCUR', 'SCORM', 'SECODA', 'SECURITY_JOURNEY', 'SELECT_STAR', 'SENDGRID', 'BREVO', 'SERVICE_NOW', 'SFTP', 'SHAREPOINT', 'SHARETRIBE', 'SHIPHERO', 'SHIPSTATION', 'SHOPIFY', 'SHOPWARE', 'SHORT_IO', 'SIFFLET', 'SIMPLECAST', 'SIMPLESAT', 'SINGLESTORE', 'SISENSE', 'SKILLJAR', 'SKUVAULT', 'SLAB', 'SMADEX', 'SNAPCHAT', 'SNOWPLOW', 'SODA', 'SONARQUBE', 'SPLIT_IO', 'SPLUNK', 'SPOTIFY', 'SPREE_COMMERCE', 'SPROUT_SOCIAL', 'SQUARE', 'SQUARESPACE', 'STACK_ADAPT', 'STATSIG', 'STRIPE', 'STYLIGHT', 'SUBSCRIPT', 'TABOOLA', 'TALKDESK', 'TALKWALKER', 'TEAMWORK_COM', 'TEMPO_IO', 'TERADATA', 'TERRAFORM', 'THE_TRADE_DESK', 'THOUGHT_SPOT', 'TIKTOK', 'TOGGL', 'TRANSCEND', 'TRELLO', 'TRISOLUTE', 'TWILIO', 'TYPEFORM', 'UPLAND', 'USERVOICE', 'VALIDIO', 'VEEVA', 'VERIZON_MEDIA', 'VITALLY', 'VONAGE', 'VUETIFY', 'WEB_SCRAPER', 'WEBHOOKS', 'WHEN_I_WORK', 'WHEREFOUR', 'WIKIPEDIA', 'WOOCOMMERCE', 'WORDPRESS', 'WORKABLE', 'WORKDAY', 'WORKFLOW_MAX', 'WRIKE', 'X', 'XERO', 'XRAY', 'YAHOO', 'YOTPO', 'YOUTUBE', 'ZEENEA', 'ZEN_CART', 'ZENDESK_CHAT', 'ZENDESK_SELL', 'ZENDESK_SUNSHINE', 'ZENDESK_SUPPORT', 'TRINET', 'ZINGTREE', 'ZOHO_BOOKS', 'ZOHO_CAMPAIGNS', 'ZOHO_CRM', 'ZOOM', 'ZUORA')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LineageEntityDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of attached_entity
        if self.attached_entity:
            _dict["attachedEntity"] = self.attached_entity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in children (list)
        _items = []
        if self.children:
            for _item_children in self.children:
                if _item_children:
                    _items.append(_item_children.to_dict())
            _dict["children"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in downstreams (list)
        _items = []
        if self.downstreams:
            for _item_downstreams in self.downstreams:
                if _item_downstreams:
                    _items.append(_item_downstreams.to_dict())
            _dict["downstreams"] = _items
        # override the default output from pydantic by calling `to_dict()` of generating_transformation_status
        if self.generating_transformation_status:
            _dict["generatingTransformationStatus"] = self.generating_transformation_status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in upstreams (list)
        _items = []
        if self.upstreams:
            for _item_upstreams in self.upstreams:
                if _item_upstreams:
                    _items.append(_item_upstreams.to_dict())
            _dict["upstreams"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LineageEntityDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "accessAuthorized": obj.get("accessAuthorized"),
                "attachedEntity": (
                    LineageAttachedEntity.from_dict(obj["attachedEntity"])
                    if obj.get("attachedEntity") is not None
                    else None
                ),
                "children": (
                    [LineageEntityDto.from_dict(_item) for _item in obj["children"]]
                    if obj.get("children") is not None
                    else None
                ),
                "datasourceName": obj.get("datasourceName"),
                "downstreams": (
                    [LineageUrnDto.from_dict(_item) for _item in obj["downstreams"]]
                    if obj.get("downstreams") is not None
                    else None
                ),
                "entityType": obj.get("entityType"),
                "generatingTransformationStatus": (
                    GeneratingTransformationStatusDto.from_dict(obj["generatingTransformationStatus"])
                    if obj.get("generatingTransformationStatus") is not None
                    else None
                ),
                "hasInformation": obj.get("hasInformation"),
                "health": obj.get("health"),
                "id": obj.get("id"),
                "platform": obj.get("platform"),
                "platformEnum": obj.get("platformEnum"),
                "qualifiedNamePrefix": obj.get("qualifiedNamePrefix"),
                "title": obj.get("title"),
                "type": obj.get("type"),
                "upstreams": (
                    [LineageUrnDto.from_dict(_item) for _item in obj["upstreams"]]
                    if obj.get("upstreams") is not None
                    else None
                ),
                "urn": obj.get("urn"),
            }
        )
        return _obj


# TODO: Rewrite to not use raise_errors
LineageEntityDto.model_rebuild(raise_errors=False)
