# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.filter_condition_group_dto import FilterConditionGroupDto
from sifflet_sdk.client.models.inclusion_config_entry_dto import InclusionConfigEntryDto
from typing_extensions import Self


class MetadataMonitoringConfigDto(BaseModel):
    """
    MetadataMonitoringConfigDto
    """  # noqa: E501

    auto_monitor_hourly_cron: Optional[StrictStr] = Field(default=None, alias="autoMonitorHourlyCron")
    exclusion_config: FilterConditionGroupDto = Field(alias="exclusionConfig")
    inclusion_config: List[InclusionConfigEntryDto] = Field(alias="inclusionConfig")
    __properties: ClassVar[List[str]] = ["autoMonitorHourlyCron", "exclusionConfig", "inclusionConfig"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MetadataMonitoringConfigDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of exclusion_config
        if self.exclusion_config:
            _dict["exclusionConfig"] = self.exclusion_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in inclusion_config (list)
        _items = []
        if self.inclusion_config:
            for _item_inclusion_config in self.inclusion_config:
                if _item_inclusion_config:
                    _items.append(_item_inclusion_config.to_dict())
            _dict["inclusionConfig"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MetadataMonitoringConfigDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "autoMonitorHourlyCron": obj.get("autoMonitorHourlyCron"),
                "exclusionConfig": (
                    FilterConditionGroupDto.from_dict(obj["exclusionConfig"])
                    if obj.get("exclusionConfig") is not None
                    else None
                ),
                "inclusionConfig": (
                    [InclusionConfigEntryDto.from_dict(_item) for _item in obj["inclusionConfig"]]
                    if obj.get("inclusionConfig") is not None
                    else None
                ),
            }
        )
        return _obj
