# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field
from sifflet_sdk.client.models.base_search_filter_dto import BaseSearchFilterDto
from sifflet_sdk.client.models.search_collection_v2_rule_catalog_asset_dto_v2 import (
    SearchCollectionV2RuleCatalogAssetDtoV2,
)
from typing_extensions import Self


class MonitoringSearchDtoV2(BaseModel):
    """
    MonitoringSearchDtoV2
    """  # noqa: E501

    catalog_filters: List[BaseSearchFilterDto] = Field(alias="catalogFilters")
    search_rules: SearchCollectionV2RuleCatalogAssetDtoV2 = Field(alias="searchRules")
    __properties: ClassVar[List[str]] = ["catalogFilters", "searchRules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MonitoringSearchDtoV2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in catalog_filters (list)
        _items = []
        if self.catalog_filters:
            for _item_catalog_filters in self.catalog_filters:
                if _item_catalog_filters:
                    _items.append(_item_catalog_filters.to_dict())
            _dict["catalogFilters"] = _items
        # override the default output from pydantic by calling `to_dict()` of search_rules
        if self.search_rules:
            _dict["searchRules"] = self.search_rules.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MonitoringSearchDtoV2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "catalogFilters": (
                    [BaseSearchFilterDto.from_dict(_item) for _item in obj["catalogFilters"]]
                    if obj.get("catalogFilters") is not None
                    else None
                ),
                "searchRules": (
                    SearchCollectionV2RuleCatalogAssetDtoV2.from_dict(obj["searchRules"])
                    if obj.get("searchRules") is not None
                    else None
                ),
            }
        )
        return _obj
