# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.public_database_schemas_scope_dto import (
    PublicDatabaseSchemasScopeDto,
)
from sifflet_sdk.client.models.public_get_last_run_v2_dto import PublicGetLastRunV2Dto
from sifflet_sdk.client.models.public_get_source_v2_dto import PublicGetSourceV2Dto
from sifflet_sdk.client.models.snowflake_information import SnowflakeInformation
from typing_extensions import Self


class PublicGetSnowflakeSourceV2Dto(PublicGetSourceV2Dto):
    """
    PublicGetSnowflakeSourceV2Dto
    """  # noqa: E501

    credentials: StrictStr = Field(description="Credentials of the source")
    schedule: Optional[StrictStr] = Field(
        default=None,
        description="Schedule of the source. Supports CRON syntax. If empty, the source won't be scheduled.",
    )
    scope: Optional[PublicDatabaseSchemasScopeDto] = None
    snowflake_information: SnowflakeInformation = Field(alias="snowflakeInformation")
    __properties: ClassVar[List[str]] = [
        "id",
        "lastRun",
        "name",
        "timezone",
        "type",
        "credentials",
        "schedule",
        "scope",
        "snowflakeInformation",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PublicGetSnowflakeSourceV2Dto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of last_run
        if self.last_run:
            _dict["lastRun"] = self.last_run.to_dict()
        # override the default output from pydantic by calling `to_dict()` of scope
        if self.scope:
            _dict["scope"] = self.scope.to_dict()
        # override the default output from pydantic by calling `to_dict()` of snowflake_information
        if self.snowflake_information:
            _dict["snowflakeInformation"] = self.snowflake_information.to_dict()
        # set to None if last_run (nullable) is None
        # and model_fields_set contains the field
        if self.last_run is None and "last_run" in self.model_fields_set:
            _dict["lastRun"] = None

        # set to None if schedule (nullable) is None
        # and model_fields_set contains the field
        if self.schedule is None and "schedule" in self.model_fields_set:
            _dict["schedule"] = None

        # set to None if scope (nullable) is None
        # and model_fields_set contains the field
        if self.scope is None and "scope" in self.model_fields_set:
            _dict["scope"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PublicGetSnowflakeSourceV2Dto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "id": obj.get("id"),
                "lastRun": PublicGetLastRunV2Dto.from_dict(obj["lastRun"]) if obj.get("lastRun") is not None else None,
                "name": obj.get("name"),
                "timezone": obj.get("timezone") if obj.get("timezone") is not None else "UTC",
                "type": obj.get("type"),
                "credentials": obj.get("credentials"),
                "schedule": obj.get("schedule"),
                "scope": (
                    PublicDatabaseSchemasScopeDto.from_dict(obj["scope"]) if obj.get("scope") is not None else None
                ),
                "snowflakeInformation": (
                    SnowflakeInformation.from_dict(obj["snowflakeInformation"])
                    if obj.get("snowflakeInformation") is not None
                    else None
                ),
            }
        )
        return _obj
