# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.public_create_source_dto_parameters import (
    PublicCreateSourceDtoParameters,
)
from sifflet_sdk.client.models.public_tag_reference_dto import PublicTagReferenceDto
from typing_extensions import Self


class PublicUpdateSourceDto(BaseModel):
    """
    PublicUpdateSourceDto
    """  # noqa: E501

    credentials: Optional[StrictStr] = Field(
        default=None,
        description="Credentials of the source. Required for all sources type except 'ATHENA', 'DBT', 'QUICKSIGHT'.",
    )
    description: Optional[StrictStr] = Field(default=None, description="Description of the source")
    name: Optional[StrictStr] = Field(default=None, description="Name of the source")
    parameters: Optional[PublicCreateSourceDtoParameters] = None
    schedule: Optional[StrictStr] = Field(
        default=None,
        description="Schedule of the source. Supports CRON syntax. If empty, the source won't be scheduled.",
    )
    tags: Optional[List[PublicTagReferenceDto]] = None
    timezone: Optional[StrictStr] = Field(
        default="UTC", description="A string representing a timezone identifier (e.g. 'UTC' or 'Europe/Paris')"
    )
    __properties: ClassVar[List[str]] = [
        "credentials",
        "description",
        "name",
        "parameters",
        "schedule",
        "tags",
        "timezone",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PublicUpdateSourceDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of parameters
        if self.parameters:
            _dict["parameters"] = self.parameters.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in tags (list)
        _items = []
        if self.tags:
            for _item_tags in self.tags:
                if _item_tags:
                    _items.append(_item_tags.to_dict())
            _dict["tags"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PublicUpdateSourceDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "credentials": obj.get("credentials"),
                "description": obj.get("description"),
                "name": obj.get("name"),
                "parameters": (
                    PublicCreateSourceDtoParameters.from_dict(obj["parameters"])
                    if obj.get("parameters") is not None
                    else None
                ),
                "schedule": obj.get("schedule"),
                "tags": (
                    [PublicTagReferenceDto.from_dict(_item) for _item in obj["tags"]]
                    if obj.get("tags") is not None
                    else None
                ),
                "timezone": obj.get("timezone") if obj.get("timezone") is not None else "UTC",
            }
        )
        return _obj
