# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.datasource_params import DatasourceParams
from sifflet_sdk.client.models.qlik_space import QlikSpace
from sifflet_sdk.client.models.time_zone_dto import TimeZoneDto
from typing_extensions import Self


class QlikParams(DatasourceParams):
    """
    QlikParams
    """  # noqa: E501

    excluded_spaces: List[QlikSpace] = Field(alias="excludedSpaces")
    host: StrictStr
    included_spaces: List[QlikSpace] = Field(alias="includedSpaces")
    __properties: ClassVar[List[str]] = [
        "datasourceType",
        "defaultRefreshRate",
        "timezoneData",
        "type",
        "excludedSpaces",
        "host",
        "includedSpaces",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QlikParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of timezone_data
        if self.timezone_data:
            _dict["timezoneData"] = self.timezone_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in excluded_spaces (list)
        _items = []
        if self.excluded_spaces:
            for _item_excluded_spaces in self.excluded_spaces:
                if _item_excluded_spaces:
                    _items.append(_item_excluded_spaces.to_dict())
            _dict["excludedSpaces"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in included_spaces (list)
        _items = []
        if self.included_spaces:
            for _item_included_spaces in self.included_spaces:
                if _item_included_spaces:
                    _items.append(_item_included_spaces.to_dict())
            _dict["includedSpaces"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QlikParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "datasourceType": obj.get("datasourceType"),
                "defaultRefreshRate": obj.get("defaultRefreshRate"),
                "timezoneData": (
                    TimeZoneDto.from_dict(obj["timezoneData"]) if obj.get("timezoneData") is not None else None
                ),
                "type": obj.get("type"),
                "excludedSpaces": (
                    [QlikSpace.from_dict(_item) for _item in obj["excludedSpaces"]]
                    if obj.get("excludedSpaces") is not None
                    else None
                ),
                "host": obj.get("host"),
                "includedSpaces": (
                    [QlikSpace.from_dict(_item) for _item in obj["includedSpaces"]]
                    if obj.get("includedSpaces") is not None
                    else None
                ),
            }
        )
        return _obj
