# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.datasource_params import DatasourceParams
from sifflet_sdk.client.models.time_zone_dto import TimeZoneDto
from typing_extensions import Self


class QuickSightParams(DatasourceParams):
    """
    QuickSightParams
    """  # noqa: E501

    account_id: StrictStr = Field(alias="accountId")
    aws_region: StrictStr = Field(alias="awsRegion")
    role_arn: StrictStr = Field(alias="roleArn")
    __properties: ClassVar[List[str]] = [
        "datasourceType",
        "defaultRefreshRate",
        "timezoneData",
        "type",
        "accountId",
        "awsRegion",
        "roleArn",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QuickSightParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of timezone_data
        if self.timezone_data:
            _dict["timezoneData"] = self.timezone_data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QuickSightParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "datasourceType": obj.get("datasourceType"),
                "defaultRefreshRate": obj.get("defaultRefreshRate"),
                "timezoneData": (
                    TimeZoneDto.from_dict(obj["timezoneData"]) if obj.get("timezoneData") is not None else None
                ),
                "type": obj.get("type"),
                "accountId": obj.get("accountId"),
                "awsRegion": obj.get("awsRegion"),
                "roleArn": obj.get("roleArn"),
            }
        )
        return _obj
