# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from importlib import import_module
from typing import TYPE_CHECKING, Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Self

if TYPE_CHECKING:
    from sifflet_sdk.client.models.interlinked_metrics_time_fiel_rule_monitoring_recommendation_change_dto import (
        InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto,
    )
    from sifflet_sdk.client.models.offset_rule_monitoring_recommendation_change_dto import (
        OffsetRuleMonitoringRecommendationChangeDto,
    )
    from sifflet_sdk.client.models.sensitivity_rule_monitoring_recommendation_change_dto import (
        SensitivityRuleMonitoringRecommendationChangeDto,
    )
    from sifflet_sdk.client.models.time_depth_rule_monitoring_recommendation_change_dto import (
        TimeDepthRuleMonitoringRecommendationChangeDto,
    )
    from sifflet_sdk.client.models.time_field_rule_monitoring_recommendation_change_dto import (
        TimeFieldRuleMonitoringRecommendationChangeDto,
    )


class RuleMonitoringRecommendationChangeDto(BaseModel):
    """
    RuleMonitoringRecommendationChangeDto
    """  # noqa: E501

    recommendation_type: StrictStr = Field(alias="recommendationType")
    __properties: ClassVar[List[str]] = ["recommendationType"]

    @field_validator("recommendation_type")
    def recommendation_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["INTERLINKED_METRIC_TIME_FIELD", "TIME_FIELD", "TIME_DEPTH", "OFFSET", "SENSITIVITY"]):
            raise ValueError(
                "must be one of enum values ('INTERLINKED_METRIC_TIME_FIELD', 'TIME_FIELD', 'TIME_DEPTH', 'OFFSET', 'SENSITIVITY')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = "recommendationType"

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        "InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto": "InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto",
        "OffsetRuleMonitoringRecommendationChangeDto": "OffsetRuleMonitoringRecommendationChangeDto",
        "SensitivityRuleMonitoringRecommendationChangeDto": "SensitivityRuleMonitoringRecommendationChangeDto",
        "TimeDepthRuleMonitoringRecommendationChangeDto": "TimeDepthRuleMonitoringRecommendationChangeDto",
        "TimeFieldRuleMonitoringRecommendationChangeDto": "TimeFieldRuleMonitoringRecommendationChangeDto",
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[
        Union[
            InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto,
            OffsetRuleMonitoringRecommendationChangeDto,
            SensitivityRuleMonitoringRecommendationChangeDto,
            TimeDepthRuleMonitoringRecommendationChangeDto,
            TimeFieldRuleMonitoringRecommendationChangeDto,
        ]
    ]:
        """Create an instance of RuleMonitoringRecommendationChangeDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[
        Union[
            InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto,
            OffsetRuleMonitoringRecommendationChangeDto,
            SensitivityRuleMonitoringRecommendationChangeDto,
            TimeDepthRuleMonitoringRecommendationChangeDto,
            TimeFieldRuleMonitoringRecommendationChangeDto,
        ]
    ]:
        """Create an instance of RuleMonitoringRecommendationChangeDto from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type == "InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto":
            return import_module(
                "sifflet_sdk.client.models.interlinked_metrics_time_fiel_rule_monitoring_recommendation_change_dto"
            ).InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto.from_dict(obj)
        if object_type == "OffsetRuleMonitoringRecommendationChangeDto":
            return import_module(
                "sifflet_sdk.client.models.offset_rule_monitoring_recommendation_change_dto"
            ).OffsetRuleMonitoringRecommendationChangeDto.from_dict(obj)
        if object_type == "SensitivityRuleMonitoringRecommendationChangeDto":
            return import_module(
                "sifflet_sdk.client.models.sensitivity_rule_monitoring_recommendation_change_dto"
            ).SensitivityRuleMonitoringRecommendationChangeDto.from_dict(obj)
        if object_type == "TimeDepthRuleMonitoringRecommendationChangeDto":
            return import_module(
                "sifflet_sdk.client.models.time_depth_rule_monitoring_recommendation_change_dto"
            ).TimeDepthRuleMonitoringRecommendationChangeDto.from_dict(obj)
        if object_type == "TimeFieldRuleMonitoringRecommendationChangeDto":
            return import_module(
                "sifflet_sdk.client.models.time_field_rule_monitoring_recommendation_change_dto"
            ).TimeFieldRuleMonitoringRecommendationChangeDto.from_dict(obj)

        raise ValueError(
            "RuleMonitoringRecommendationChangeDto failed to lookup discriminator value from "
            + json.dumps(obj)
            + ". Discriminator property name: "
            + cls.__discriminator_property_name
            + ", mapping: "
            + json.dumps(cls.__discriminator_value_class_map)
        )
