# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.interlinked_metrics_time_fiel_rule_monitoring_recommendation_change_dto import (
    InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto,
)
from sifflet_sdk.client.models.offset_rule_monitoring_recommendation_change_dto import (
    OffsetRuleMonitoringRecommendationChangeDto,
)
from sifflet_sdk.client.models.sensitivity_rule_monitoring_recommendation_change_dto import (
    SensitivityRuleMonitoringRecommendationChangeDto,
)
from sifflet_sdk.client.models.time_depth_rule_monitoring_recommendation_change_dto import (
    TimeDepthRuleMonitoringRecommendationChangeDto,
)
from sifflet_sdk.client.models.time_field_rule_monitoring_recommendation_change_dto import (
    TimeFieldRuleMonitoringRecommendationChangeDto,
)
from typing_extensions import Literal, Self

RULEMONITORINGRECOMMENDATIONDTOCHANGESINNER_ONE_OF_SCHEMAS = [
    "InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto",
    "OffsetRuleMonitoringRecommendationChangeDto",
    "SensitivityRuleMonitoringRecommendationChangeDto",
    "TimeDepthRuleMonitoringRecommendationChangeDto",
    "TimeFieldRuleMonitoringRecommendationChangeDto",
]


class RuleMonitoringRecommendationDtoChangesInner(BaseModel):
    """
    RuleMonitoringRecommendationDtoChangesInner
    """

    # data type: InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto
    oneof_schema_1_validator: Optional[InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto] = None
    # data type: OffsetRuleMonitoringRecommendationChangeDto
    oneof_schema_2_validator: Optional[OffsetRuleMonitoringRecommendationChangeDto] = None
    # data type: SensitivityRuleMonitoringRecommendationChangeDto
    oneof_schema_3_validator: Optional[SensitivityRuleMonitoringRecommendationChangeDto] = None
    # data type: TimeDepthRuleMonitoringRecommendationChangeDto
    oneof_schema_4_validator: Optional[TimeDepthRuleMonitoringRecommendationChangeDto] = None
    # data type: TimeFieldRuleMonitoringRecommendationChangeDto
    oneof_schema_5_validator: Optional[TimeFieldRuleMonitoringRecommendationChangeDto] = None
    actual_instance: Optional[
        Union[
            InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto,
            OffsetRuleMonitoringRecommendationChangeDto,
            SensitivityRuleMonitoringRecommendationChangeDto,
            TimeDepthRuleMonitoringRecommendationChangeDto,
            TimeFieldRuleMonitoringRecommendationChangeDto,
        ]
    ] = None
    one_of_schemas: Set[str] = {
        "InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto",
        "OffsetRuleMonitoringRecommendationChangeDto",
        "SensitivityRuleMonitoringRecommendationChangeDto",
        "TimeDepthRuleMonitoringRecommendationChangeDto",
        "TimeFieldRuleMonitoringRecommendationChangeDto",
    }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = RuleMonitoringRecommendationDtoChangesInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto
        if not isinstance(v, InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto`"
            )
        else:
            match += 1
        # validate data type: OffsetRuleMonitoringRecommendationChangeDto
        if not isinstance(v, OffsetRuleMonitoringRecommendationChangeDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `OffsetRuleMonitoringRecommendationChangeDto`")
        else:
            match += 1
        # validate data type: SensitivityRuleMonitoringRecommendationChangeDto
        if not isinstance(v, SensitivityRuleMonitoringRecommendationChangeDto):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `SensitivityRuleMonitoringRecommendationChangeDto`"
            )
        else:
            match += 1
        # validate data type: TimeDepthRuleMonitoringRecommendationChangeDto
        if not isinstance(v, TimeDepthRuleMonitoringRecommendationChangeDto):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `TimeDepthRuleMonitoringRecommendationChangeDto`"
            )
        else:
            match += 1
        # validate data type: TimeFieldRuleMonitoringRecommendationChangeDto
        if not isinstance(v, TimeFieldRuleMonitoringRecommendationChangeDto):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `TimeFieldRuleMonitoringRecommendationChangeDto`"
            )
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in RuleMonitoringRecommendationDtoChangesInner with oneOf schemas: InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto, OffsetRuleMonitoringRecommendationChangeDto, SensitivityRuleMonitoringRecommendationChangeDto, TimeDepthRuleMonitoringRecommendationChangeDto, TimeFieldRuleMonitoringRecommendationChangeDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in RuleMonitoringRecommendationDtoChangesInner with oneOf schemas: InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto, OffsetRuleMonitoringRecommendationChangeDto, SensitivityRuleMonitoringRecommendationChangeDto, TimeDepthRuleMonitoringRecommendationChangeDto, TimeFieldRuleMonitoringRecommendationChangeDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("recommendationType")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `recommendationType` in the input.")

        # check if data type is `InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto`
        if _data_type == "InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto":
            instance.actual_instance = InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto.from_json(
                json_str
            )
            return instance

        # check if data type is `OffsetRuleMonitoringRecommendationChangeDto`
        if _data_type == "OffsetRuleMonitoringRecommendationChangeDto":
            instance.actual_instance = OffsetRuleMonitoringRecommendationChangeDto.from_json(json_str)
            return instance

        # check if data type is `SensitivityRuleMonitoringRecommendationChangeDto`
        if _data_type == "SensitivityRuleMonitoringRecommendationChangeDto":
            instance.actual_instance = SensitivityRuleMonitoringRecommendationChangeDto.from_json(json_str)
            return instance

        # check if data type is `TimeDepthRuleMonitoringRecommendationChangeDto`
        if _data_type == "TimeDepthRuleMonitoringRecommendationChangeDto":
            instance.actual_instance = TimeDepthRuleMonitoringRecommendationChangeDto.from_json(json_str)
            return instance

        # check if data type is `TimeFieldRuleMonitoringRecommendationChangeDto`
        if _data_type == "TimeFieldRuleMonitoringRecommendationChangeDto":
            instance.actual_instance = TimeFieldRuleMonitoringRecommendationChangeDto.from_json(json_str)
            return instance

        # deserialize data into InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto
        try:
            instance.actual_instance = InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto.from_json(
                json_str
            )
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into OffsetRuleMonitoringRecommendationChangeDto
        try:
            instance.actual_instance = OffsetRuleMonitoringRecommendationChangeDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SensitivityRuleMonitoringRecommendationChangeDto
        try:
            instance.actual_instance = SensitivityRuleMonitoringRecommendationChangeDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TimeDepthRuleMonitoringRecommendationChangeDto
        try:
            instance.actual_instance = TimeDepthRuleMonitoringRecommendationChangeDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TimeFieldRuleMonitoringRecommendationChangeDto
        try:
            instance.actual_instance = TimeFieldRuleMonitoringRecommendationChangeDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into RuleMonitoringRecommendationDtoChangesInner with oneOf schemas: InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto, OffsetRuleMonitoringRecommendationChangeDto, SensitivityRuleMonitoringRecommendationChangeDto, TimeDepthRuleMonitoringRecommendationChangeDto, TimeFieldRuleMonitoringRecommendationChangeDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into RuleMonitoringRecommendationDtoChangesInner with oneOf schemas: InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto, OffsetRuleMonitoringRecommendationChangeDto, SensitivityRuleMonitoringRecommendationChangeDto, TimeDepthRuleMonitoringRecommendationChangeDto, TimeFieldRuleMonitoringRecommendationChangeDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[
        Union[
            Dict[str, Any],
            InterlinkedMetricsTimeFielRuleMonitoringRecommendationChangeDto,
            OffsetRuleMonitoringRecommendationChangeDto,
            SensitivityRuleMonitoringRecommendationChangeDto,
            TimeDepthRuleMonitoringRecommendationChangeDto,
            TimeFieldRuleMonitoringRecommendationChangeDto,
        ]
    ]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
