# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from sifflet_sdk.client.models.parameterized_query_dto import ParameterizedQueryDto
from sifflet_sdk.client.models.rule_run_discrepancy import RuleRunDiscrepancy
from typing_extensions import Self


class RuleRunDetailsByGroup(BaseModel):
    """
    RuleRunDetailsByGroup
    """  # noqa: E501

    debug: Optional[ParameterizedQueryDto] = None
    discrepancies: Optional[List[RuleRunDiscrepancy]] = None
    encrypted_group_value: Optional[StrictStr] = Field(default=None, alias="encryptedGroupValue")
    execution_data: Optional[Dict[str, Dict[str, Any]]] = Field(default=None, alias="executionData")
    group_key: Optional[List[StrictStr]] = Field(default=None, alias="groupKey")
    group_value: Optional[StrictStr] = Field(default=None, alias="groupValue")
    hashed_group_value: Optional[StrictStr] = Field(default=None, alias="hashedGroupValue")
    result: Optional[StrictStr] = None
    status: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = [
        "debug",
        "discrepancies",
        "encryptedGroupValue",
        "executionData",
        "groupKey",
        "groupValue",
        "hashedGroupValue",
        "result",
        "status",
    ]

    @field_validator("status")
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["SUCCESS", "REQUIRES_YOUR_ATTENTION", "TECHNICAL_ERROR", "FAILED"]):
            raise ValueError(
                "must be one of enum values ('SUCCESS', 'REQUIRES_YOUR_ATTENTION', 'TECHNICAL_ERROR', 'FAILED')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RuleRunDetailsByGroup from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of debug
        if self.debug:
            _dict["debug"] = self.debug.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in discrepancies (list)
        _items = []
        if self.discrepancies:
            for _item_discrepancies in self.discrepancies:
                if _item_discrepancies:
                    _items.append(_item_discrepancies.to_dict())
            _dict["discrepancies"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RuleRunDetailsByGroup from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "debug": ParameterizedQueryDto.from_dict(obj["debug"]) if obj.get("debug") is not None else None,
                "discrepancies": (
                    [RuleRunDiscrepancy.from_dict(_item) for _item in obj["discrepancies"]]
                    if obj.get("discrepancies") is not None
                    else None
                ),
                "encryptedGroupValue": obj.get("encryptedGroupValue"),
                "executionData": obj.get("executionData"),
                "groupKey": obj.get("groupKey"),
                "groupValue": obj.get("groupValue"),
                "hashedGroupValue": obj.get("hashedGroupValue"),
                "result": obj.get("result"),
                "status": obj.get("status"),
            }
        )
        return _obj
