# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from sifflet_sdk.client.models.join_params import JoinParams
from sifflet_sdk.client.models.strongly_typed_rule_input_params import (
    StronglyTypedRuleInputParams,
)
from typing_extensions import Self


class RuleRunInput(BaseModel):
    """
    RuleRunInput
    """  # noqa: E501

    dataset_ids: Optional[List[Optional[StrictStr]]] = Field(default=None, alias="datasetIds")
    join_params: Optional[JoinParams] = Field(default=None, alias="joinParams")
    previous_run_id: Optional[StrictStr] = Field(default=None, alias="previousRunId")
    rule_input_values: Optional[StronglyTypedRuleInputParams] = Field(default=None, alias="ruleInputValues")
    rule_template_name: Optional[StrictStr] = Field(default=None, alias="ruleTemplateName")
    __properties: ClassVar[List[str]] = [
        "datasetIds",
        "joinParams",
        "previousRunId",
        "ruleInputValues",
        "ruleTemplateName",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RuleRunInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of join_params
        if self.join_params:
            _dict["joinParams"] = self.join_params.to_dict()
        # override the default output from pydantic by calling `to_dict()` of rule_input_values
        if self.rule_input_values:
            _dict["ruleInputValues"] = self.rule_input_values.to_dict()
        # set to None if dataset_ids (nullable) is None
        # and model_fields_set contains the field
        if self.dataset_ids is None and "dataset_ids" in self.model_fields_set:
            _dict["datasetIds"] = None

        # set to None if join_params (nullable) is None
        # and model_fields_set contains the field
        if self.join_params is None and "join_params" in self.model_fields_set:
            _dict["joinParams"] = None

        # set to None if previous_run_id (nullable) is None
        # and model_fields_set contains the field
        if self.previous_run_id is None and "previous_run_id" in self.model_fields_set:
            _dict["previousRunId"] = None

        # set to None if rule_template_name (nullable) is None
        # and model_fields_set contains the field
        if self.rule_template_name is None and "rule_template_name" in self.model_fields_set:
            _dict["ruleTemplateName"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RuleRunInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "datasetIds": obj.get("datasetIds"),
                "joinParams": JoinParams.from_dict(obj["joinParams"]) if obj.get("joinParams") is not None else None,
                "previousRunId": obj.get("previousRunId"),
                "ruleInputValues": (
                    StronglyTypedRuleInputParams.from_dict(obj["ruleInputValues"])
                    if obj.get("ruleInputValues") is not None
                    else None
                ),
                "ruleTemplateName": obj.get("ruleTemplateName"),
            }
        )
        return _obj
