# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from sifflet_sdk.client.models.input_cardinality_dto import InputCardinalityDto
from typing_extensions import Self


class RuleTemplateBrief(BaseModel):
    """
    RuleTemplateBrief
    """  # noqa: E501

    accept_datasets_from_different_datasource: StrictBool = Field(alias="acceptDatasetsFromDifferentDatasource")
    available_datasources: Optional[List[StrictStr]] = Field(default=None, alias="availableDatasources")
    description: Optional[StrictStr] = None
    duplicate_datasets: Optional[StrictBool] = Field(default=None, alias="duplicateDatasets")
    enabled: StrictBool
    input_cardinality: Optional[InputCardinalityDto] = Field(default=None, alias="inputCardinality")
    label: Optional[StrictStr] = None
    name: StrictStr
    support_as_code_yaml_conversion: StrictBool = Field(alias="supportAsCodeYAMLConversion")
    supports_joining: StrictBool = Field(alias="supportsJoining")
    supports_views: StrictBool = Field(alias="supportsViews")
    __properties: ClassVar[List[str]] = [
        "acceptDatasetsFromDifferentDatasource",
        "availableDatasources",
        "description",
        "duplicateDatasets",
        "enabled",
        "inputCardinality",
        "label",
        "name",
        "supportAsCodeYAMLConversion",
        "supportsJoining",
        "supportsViews",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RuleTemplateBrief from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of input_cardinality
        if self.input_cardinality:
            _dict["inputCardinality"] = self.input_cardinality.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RuleTemplateBrief from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "acceptDatasetsFromDifferentDatasource": obj.get("acceptDatasetsFromDifferentDatasource"),
                "availableDatasources": obj.get("availableDatasources"),
                "description": obj.get("description"),
                "duplicateDatasets": obj.get("duplicateDatasets"),
                "enabled": obj.get("enabled"),
                "inputCardinality": (
                    InputCardinalityDto.from_dict(obj["inputCardinality"])
                    if obj.get("inputCardinality") is not None
                    else None
                ),
                "label": obj.get("label"),
                "name": obj.get("name"),
                "supportAsCodeYAMLConversion": obj.get("supportAsCodeYAMLConversion"),
                "supportsJoining": obj.get("supportsJoining"),
                "supportsViews": obj.get("supportsViews"),
            }
        )
        return _obj
