# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import (
    ConfigDict,
    Field,
    StrictFloat,
    StrictInt,
    StrictStr,
    field_validator,
)
from sifflet_sdk.client.models.datapoint_dto import DatapointDto
from sifflet_sdk.client.models.special_date import SpecialDate
from typing_extensions import Self


class ScalarExpectationDatapointDto(DatapointDto):
    """
    ScalarExpectationDatapointDto
    """  # noqa: E501

    anomaly_importance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="anomalyImportance")
    anomaly_position: Optional[StrictStr] = Field(default=None, alias="anomalyPosition")
    expected_value: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="expectedValue")
    expected_value_max: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="expectedValueMax")
    expected_value_min: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="expectedValueMin")
    special_dates: List[SpecialDate] = Field(alias="specialDates")
    status: StrictStr
    __properties: ClassVar[List[str]] = [
        "date",
        "groupValuesHash",
        "type",
        "anomalyImportance",
        "anomalyPosition",
        "expectedValue",
        "expectedValueMax",
        "expectedValueMin",
        "specialDates",
        "status",
    ]

    @field_validator("anomaly_position")
    def anomaly_position_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["ABOVE_EXPECTED_RANGE", "BELOW_EXPECTED_RANGE"]):
            raise ValueError("must be one of enum values ('ABOVE_EXPECTED_RANGE', 'BELOW_EXPECTED_RANGE')")
        return value

    @field_validator("status")
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["NOT_CHECKED", "EXPECTED", "ANOMALY"]):
            raise ValueError("must be one of enum values ('NOT_CHECKED', 'EXPECTED', 'ANOMALY')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScalarExpectationDatapointDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in special_dates (list)
        _items = []
        if self.special_dates:
            for _item_special_dates in self.special_dates:
                if _item_special_dates:
                    _items.append(_item_special_dates.to_dict())
            _dict["specialDates"] = _items
        # set to None if group_values_hash (nullable) is None
        # and model_fields_set contains the field
        if self.group_values_hash is None and "group_values_hash" in self.model_fields_set:
            _dict["groupValuesHash"] = None

        # set to None if anomaly_importance (nullable) is None
        # and model_fields_set contains the field
        if self.anomaly_importance is None and "anomaly_importance" in self.model_fields_set:
            _dict["anomalyImportance"] = None

        # set to None if anomaly_position (nullable) is None
        # and model_fields_set contains the field
        if self.anomaly_position is None and "anomaly_position" in self.model_fields_set:
            _dict["anomalyPosition"] = None

        # set to None if expected_value (nullable) is None
        # and model_fields_set contains the field
        if self.expected_value is None and "expected_value" in self.model_fields_set:
            _dict["expectedValue"] = None

        # set to None if expected_value_max (nullable) is None
        # and model_fields_set contains the field
        if self.expected_value_max is None and "expected_value_max" in self.model_fields_set:
            _dict["expectedValueMax"] = None

        # set to None if expected_value_min (nullable) is None
        # and model_fields_set contains the field
        if self.expected_value_min is None and "expected_value_min" in self.model_fields_set:
            _dict["expectedValueMin"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScalarExpectationDatapointDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "date": obj.get("date"),
                "groupValuesHash": obj.get("groupValuesHash"),
                "type": obj.get("type"),
                "anomalyImportance": obj.get("anomalyImportance"),
                "anomalyPosition": obj.get("anomalyPosition"),
                "expectedValue": obj.get("expectedValue"),
                "expectedValueMax": obj.get("expectedValueMax"),
                "expectedValueMin": obj.get("expectedValueMin"),
                "specialDates": (
                    [SpecialDate.from_dict(_item) for _item in obj["specialDates"]]
                    if obj.get("specialDates") is not None
                    else None
                ),
                "status": obj.get("status"),
            }
        )
        return _obj
