# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.asset_summary_dto import AssetSummaryDto
from sifflet_sdk.client.models.monitor_summary_dto import MonitorSummaryDto
from typing_extensions import Literal, Self

SEARCHCOLLECTIONASSETSUMMARYDTODATAINNER_ONE_OF_SCHEMAS = ["AssetSummaryDto", "MonitorSummaryDto"]


class SearchCollectionAssetSummaryDtoDataInner(BaseModel):
    """
    SearchCollectionAssetSummaryDtoDataInner
    """

    # data type: AssetSummaryDto
    oneof_schema_1_validator: Optional[AssetSummaryDto] = None
    # data type: MonitorSummaryDto
    oneof_schema_2_validator: Optional[MonitorSummaryDto] = None
    actual_instance: Optional[Union[AssetSummaryDto, MonitorSummaryDto]] = None
    one_of_schemas: Set[str] = {"AssetSummaryDto", "MonitorSummaryDto"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = SearchCollectionAssetSummaryDtoDataInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: AssetSummaryDto
        if not isinstance(v, AssetSummaryDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AssetSummaryDto`")
        else:
            match += 1
        # validate data type: MonitorSummaryDto
        if not isinstance(v, MonitorSummaryDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MonitorSummaryDto`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in SearchCollectionAssetSummaryDtoDataInner with oneOf schemas: AssetSummaryDto, MonitorSummaryDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in SearchCollectionAssetSummaryDtoDataInner with oneOf schemas: AssetSummaryDto, MonitorSummaryDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AssetSummaryDto
        try:
            instance.actual_instance = AssetSummaryDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MonitorSummaryDto
        try:
            instance.actual_instance = MonitorSummaryDto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into SearchCollectionAssetSummaryDtoDataInner with oneOf schemas: AssetSummaryDto, MonitorSummaryDto. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into SearchCollectionAssetSummaryDtoDataInner with oneOf schemas: AssetSummaryDto, MonitorSummaryDto. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AssetSummaryDto, MonitorSummaryDto]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
