# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import ConfigDict, Field, StrictInt, StrictStr, field_validator
from sifflet_sdk.client.models.incident_event_dto import IncidentEventDto
from sifflet_sdk.client.models.user_dto import UserDto
from typing_extensions import Self


class StatusChangeIncidentEventDto(IncidentEventDto):
    """
    StatusChangeIncidentEventDto
    """  # noqa: E501

    changed_by_user: Optional[UserDto] = Field(default=None, alias="changedByUser")
    first_date: StrictInt = Field(alias="firstDate")
    last_date: StrictInt = Field(alias="lastDate")
    new_qualification: Optional[StrictStr] = Field(default=None, alias="newQualification")
    new_status: StrictStr = Field(alias="newStatus")
    old_qualification: Optional[StrictStr] = Field(default=None, alias="oldQualification")
    old_status: StrictStr = Field(alias="oldStatus")
    __properties: ClassVar[List[str]] = [
        "date",
        "type",
        "changedByUser",
        "firstDate",
        "lastDate",
        "newQualification",
        "newStatus",
        "oldQualification",
        "oldStatus",
    ]

    @field_validator("new_qualification")
    def new_qualification_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "FIXED",
                "FALSE_POSITIVE",
                "NO_ACTION_NEEDED",
                "REVIEWED",
                "DUPLICATE",
                "AUTOMATIC",
                "QUALIFIED_MONITORS_REVIEWED",
                "QUALIFIED_MONITORS_NO_ACTION_NEEDED",
                "QUALIFIED_MONITORS_FALSE_POSITIVE",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('FIXED', 'FALSE_POSITIVE', 'NO_ACTION_NEEDED', 'REVIEWED', 'DUPLICATE', 'AUTOMATIC', 'QUALIFIED_MONITORS_REVIEWED', 'QUALIFIED_MONITORS_NO_ACTION_NEEDED', 'QUALIFIED_MONITORS_FALSE_POSITIVE')"
            )
        return value

    @field_validator("new_status")
    def new_status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["OPEN", "IN_PROGRESS", "CLOSED"]):
            raise ValueError("must be one of enum values ('OPEN', 'IN_PROGRESS', 'CLOSED')")
        return value

    @field_validator("old_qualification")
    def old_qualification_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "FIXED",
                "FALSE_POSITIVE",
                "NO_ACTION_NEEDED",
                "REVIEWED",
                "DUPLICATE",
                "AUTOMATIC",
                "QUALIFIED_MONITORS_REVIEWED",
                "QUALIFIED_MONITORS_NO_ACTION_NEEDED",
                "QUALIFIED_MONITORS_FALSE_POSITIVE",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('FIXED', 'FALSE_POSITIVE', 'NO_ACTION_NEEDED', 'REVIEWED', 'DUPLICATE', 'AUTOMATIC', 'QUALIFIED_MONITORS_REVIEWED', 'QUALIFIED_MONITORS_NO_ACTION_NEEDED', 'QUALIFIED_MONITORS_FALSE_POSITIVE')"
            )
        return value

    @field_validator("old_status")
    def old_status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["OPEN", "IN_PROGRESS", "CLOSED"]):
            raise ValueError("must be one of enum values ('OPEN', 'IN_PROGRESS', 'CLOSED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StatusChangeIncidentEventDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of changed_by_user
        if self.changed_by_user:
            _dict["changedByUser"] = self.changed_by_user.to_dict()
        # set to None if new_qualification (nullable) is None
        # and model_fields_set contains the field
        if self.new_qualification is None and "new_qualification" in self.model_fields_set:
            _dict["newQualification"] = None

        # set to None if old_qualification (nullable) is None
        # and model_fields_set contains the field
        if self.old_qualification is None and "old_qualification" in self.model_fields_set:
            _dict["oldQualification"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StatusChangeIncidentEventDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "date": obj.get("date"),
                "type": obj.get("type"),
                "changedByUser": (
                    UserDto.from_dict(obj["changedByUser"]) if obj.get("changedByUser") is not None else None
                ),
                "firstDate": obj.get("firstDate"),
                "lastDate": obj.get("lastDate"),
                "newQualification": obj.get("newQualification"),
                "newStatus": obj.get("newStatus"),
                "oldQualification": obj.get("oldQualification"),
                "oldStatus": obj.get("oldStatus"),
            }
        )
        return _obj
