# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Self


class TimeSeries(BaseModel):
    """
    TimeSeries
    """  # noqa: E501

    comparison_date: StrictStr = Field(alias="comparisonDate")
    first_run_detection_start_date: Optional[StrictStr] = Field(default=None, alias="firstRunDetectionStartDate")
    graph_type: Optional[StrictStr] = Field(default=None, alias="graphType")
    json_file_bucket: Optional[StrictStr] = Field(default=None, alias="jsonFileBucket")
    json_file_key: Optional[StrictStr] = Field(default=None, alias="jsonFileKey")
    json_file_path: Optional[StrictStr] = Field(default=None, alias="jsonFilePath")
    s3_region_name: Optional[StrictStr] = Field(default=None, alias="s3RegionName")
    time_field: Optional[StrictStr] = Field(default=None, alias="timeField")
    time_frequency: Optional[StrictStr] = Field(default=None, alias="timeFrequency")
    __properties: ClassVar[List[str]] = [
        "comparisonDate",
        "firstRunDetectionStartDate",
        "graphType",
        "jsonFileBucket",
        "jsonFileKey",
        "jsonFilePath",
        "s3RegionName",
        "timeField",
        "timeFrequency",
    ]

    @field_validator("graph_type")
    def graph_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "DUPLICATE",
                "DUPLICATE_COUNT",
                "DUPLICATE_PERCENTAGE",
                "NULL_COUNT",
                "NULL_PERCENTAGE",
                "COMPLETENESS",
                "FRESHNESS",
                "METADATA_FRESHNESS",
                "NUMERICAL_TRANSFORMATION",
                "DISTRIBUTION",
                "MULTI_METRICS_GLOBAL_TIME_SERIES",
                "MULTI_METRICS_DIFFERENCE_TIME_SERIES",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('DUPLICATE', 'DUPLICATE_COUNT', 'DUPLICATE_PERCENTAGE', 'NULL_COUNT', 'NULL_PERCENTAGE', 'COMPLETENESS', 'FRESHNESS', 'METADATA_FRESHNESS', 'NUMERICAL_TRANSFORMATION', 'DISTRIBUTION', 'MULTI_METRICS_GLOBAL_TIME_SERIES', 'MULTI_METRICS_DIFFERENCE_TIME_SERIES')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TimeSeries from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TimeSeries from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "comparisonDate": obj.get("comparisonDate"),
                "firstRunDetectionStartDate": obj.get("firstRunDetectionStartDate"),
                "graphType": obj.get("graphType"),
                "jsonFileBucket": obj.get("jsonFileBucket"),
                "jsonFileKey": obj.get("jsonFileKey"),
                "jsonFilePath": obj.get("jsonFilePath"),
                "s3RegionName": obj.get("s3RegionName"),
                "timeField": obj.get("timeField"),
                "timeFrequency": obj.get("timeFrequency"),
            }
        )
        return _obj
