# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing_extensions import Self


class TimeWindow(BaseModel):
    """
    TimeWindow
    """  # noqa: E501

    has_offset: Optional[StrictBool] = Field(default=None, alias="hasOffset")
    has_time_window: Optional[StrictBool] = Field(default=None, alias="hasTimeWindow")
    offset_unit: Optional[StrictStr] = Field(default=None, alias="offsetUnit")
    offset_value: Optional[StrictInt] = Field(default=None, alias="offsetValue")
    time_window_field: Optional[StrictStr] = Field(default=None, alias="timeWindowField")
    time_window_field_type: Optional[StrictStr] = Field(default=None, alias="timeWindowFieldType")
    time_window_last: Optional[StrictInt] = Field(default=None, alias="timeWindowLast")
    time_window_unit: Optional[StrictStr] = Field(default=None, alias="timeWindowUnit")
    __properties: ClassVar[List[str]] = [
        "hasOffset",
        "hasTimeWindow",
        "offsetUnit",
        "offsetValue",
        "timeWindowField",
        "timeWindowFieldType",
        "timeWindowLast",
        "timeWindowUnit",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TimeWindow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TimeWindow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "hasOffset": obj.get("hasOffset"),
                "hasTimeWindow": obj.get("hasTimeWindow"),
                "offsetUnit": obj.get("offsetUnit"),
                "offsetValue": obj.get("offsetValue"),
                "timeWindowField": obj.get("timeWindowField"),
                "timeWindowFieldType": obj.get("timeWindowFieldType"),
                "timeWindowLast": obj.get("timeWindowLast"),
                "timeWindowUnit": obj.get("timeWindowUnit"),
            }
        )
        return _obj
