# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from sifflet_sdk.client.models.change_dto import ChangeDto
from sifflet_sdk.client.models.log_dto import LogDto
from typing_extensions import Self


class WorkspaceApplyObjectResponseDto(BaseModel):
    """
    WorkspaceApplyObjectResponseDto
    """  # noqa: E501

    change: Optional[ChangeDto] = None
    id: Optional[StrictStr] = None
    kind: Optional[StrictStr] = None
    logs: Optional[List[LogDto]] = None
    status: Optional[StrictStr] = None
    sub_status: Optional[StrictStr] = Field(default=None, alias="subStatus")
    __properties: ClassVar[List[str]] = ["change", "id", "kind", "logs", "status", "subStatus"]

    @field_validator("status")
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["OK", "Error", "Fatal"]):
            raise ValueError("must be one of enum values ('OK', 'Error', 'Fatal')")
        return value

    @field_validator("sub_status")
    def sub_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            ["Success", "Skipped", "ValidationError", "DeserializationError", "Unauthorized", "InternalServerError"]
        ):
            raise ValueError(
                "must be one of enum values ('Success', 'Skipped', 'ValidationError', 'DeserializationError', 'Unauthorized', 'InternalServerError')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkspaceApplyObjectResponseDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of change
        if self.change:
            _dict["change"] = self.change.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in logs (list)
        _items = []
        if self.logs:
            for _item_logs in self.logs:
                if _item_logs:
                    _items.append(_item_logs.to_dict())
            _dict["logs"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkspaceApplyObjectResponseDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "change": ChangeDto.from_dict(obj["change"]) if obj.get("change") is not None else None,
                "id": obj.get("id"),
                "kind": obj.get("kind"),
                "logs": [LogDto.from_dict(_item) for _item in obj["logs"]] if obj.get("logs") is not None else None,
                "status": obj.get("status"),
                "subStatus": obj.get("subStatus"),
            }
        )
        return _obj
