# coding: utf-8

"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
from typing import Any, Dict, List, Optional, Set, Union

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictStr,
    ValidationError,
    field_validator,
)
from sifflet_sdk.client.models.success_list_string_payload import (
    SuccessListStringPayload,
)
from sifflet_sdk.client.models.success_query_result_payload import (
    SuccessQueryResultPayload,
)
from sifflet_sdk.client.models.success_string_payload import SuccessStringPayload
from typing_extensions import Literal, Self

JOBRESULTSUCCESSDATAALLOFPAYLOAD_ONE_OF_SCHEMAS = [
    "SuccessListStringPayload",
    "SuccessQueryResultPayload",
    "SuccessStringPayload",
]


class JobResultSuccessDataAllOfPayload(BaseModel):
    """
    JobResultSuccessDataAllOfPayload
    """

    # data type: SuccessListStringPayload
    oneof_schema_1_validator: Optional[SuccessListStringPayload] = None
    # data type: SuccessQueryResultPayload
    oneof_schema_2_validator: Optional[SuccessQueryResultPayload] = None
    # data type: SuccessStringPayload
    oneof_schema_3_validator: Optional[SuccessStringPayload] = None
    actual_instance: Optional[Union[SuccessListStringPayload, SuccessQueryResultPayload, SuccessStringPayload]] = None
    one_of_schemas: Set[str] = {"SuccessListStringPayload", "SuccessQueryResultPayload", "SuccessStringPayload"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = JobResultSuccessDataAllOfPayload.model_construct()
        error_messages = []
        match = 0
        # validate data type: SuccessListStringPayload
        if not isinstance(v, SuccessListStringPayload):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SuccessListStringPayload`")
        else:
            match += 1
        # validate data type: SuccessQueryResultPayload
        if not isinstance(v, SuccessQueryResultPayload):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SuccessQueryResultPayload`")
        else:
            match += 1
        # validate data type: SuccessStringPayload
        if not isinstance(v, SuccessStringPayload):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SuccessStringPayload`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in JobResultSuccessDataAllOfPayload with oneOf schemas: SuccessListStringPayload, SuccessQueryResultPayload, SuccessStringPayload. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in JobResultSuccessDataAllOfPayload with oneOf schemas: SuccessListStringPayload, SuccessQueryResultPayload, SuccessStringPayload. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `SuccessListStringPayload`
        if _data_type == "LIST_STRING":
            instance.actual_instance = SuccessListStringPayload.from_json(json_str)
            return instance

        # check if data type is `SuccessQueryResultPayload`
        if _data_type == "QUERY_RESULT":
            instance.actual_instance = SuccessQueryResultPayload.from_json(json_str)
            return instance

        # check if data type is `SuccessStringPayload`
        if _data_type == "STRING":
            instance.actual_instance = SuccessStringPayload.from_json(json_str)
            return instance

        # check if data type is `SuccessListStringPayload`
        if _data_type == "SuccessListStringPayload":
            instance.actual_instance = SuccessListStringPayload.from_json(json_str)
            return instance

        # check if data type is `SuccessQueryResultPayload`
        if _data_type == "SuccessQueryResultPayload":
            instance.actual_instance = SuccessQueryResultPayload.from_json(json_str)
            return instance

        # check if data type is `SuccessStringPayload`
        if _data_type == "SuccessStringPayload":
            instance.actual_instance = SuccessStringPayload.from_json(json_str)
            return instance

        # deserialize data into SuccessListStringPayload
        try:
            instance.actual_instance = SuccessListStringPayload.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SuccessQueryResultPayload
        try:
            instance.actual_instance = SuccessQueryResultPayload.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SuccessStringPayload
        try:
            instance.actual_instance = SuccessStringPayload.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into JobResultSuccessDataAllOfPayload with oneOf schemas: SuccessListStringPayload, SuccessQueryResultPayload, SuccessStringPayload. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into JobResultSuccessDataAllOfPayload with oneOf schemas: SuccessListStringPayload, SuccessQueryResultPayload, SuccessStringPayload. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[Union[Dict[str, Any], SuccessListStringPayload, SuccessQueryResultPayload, SuccessStringPayload]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
